
# procedure to show window .
proc ShowWindow. {args} {
    
    # Window manager configurations
    global tk_version
    wm positionfrom . user
    wm sizefrom . user
    wm maxsize . 600 600
    wm minsize . 100 100
    if {$tk_version >= 3.0} {
        wm protocol . WM_DELETE_WINDOW {recall deleteWindow}
    }
    wm title . {Graph Inspector}


    # build widget .insp_graph
    frame .insp_graph \
            -background {gainsboro} \
            -relief {raised}
    
    # build widget .insp_graph.number
    frame .insp_graph.number \
            -background {gainsboro} \
            -borderwidth {1} \
            -relief {raised}
    
    # build widget .insp_graph.number.nodes
    frame .insp_graph.number.nodes \
            -background {gainsboro}
    
    # build widget .insp_graph.number.nodes.label
    label .insp_graph.number.nodes.label \
            -anchor {w} \
            -background {gainsboro} \
            -foreground {black} \
            -text {Number of Nodes:} \
            -width {16}
    
    # build widget .insp_graph.number.nodes.entry
    entry .insp_graph.number.nodes.entry \
            -background {gainsboro} \
            -foreground {black} \
            -insertbackground {black} \
            -selectbackground {black} \
            -selectforeground {gainsboro}
    
    # pack widget .insp_graph.number.nodes
    pack append .insp_graph.number.nodes \
            .insp_graph.number.nodes.label {left frame center} \
            .insp_graph.number.nodes.entry {left frame center expand fillx}
    
    
    # build widget .insp_graph.number.edges
    frame .insp_graph.number.edges \
            -background {gainsboro}
    
    # build widget .insp_graph.number.edges.label
    label .insp_graph.number.edges.label \
            -anchor {w} \
            -background {gainsboro} \
            -foreground {black} \
            -text {Number of Edges:} \
            -width {16}
    
    # build widget .insp_graph.number.edges.entry
    entry .insp_graph.number.edges.entry \
            -background {gainsboro} \
            -foreground {black} \
            -insertbackground {black} \
            -selectbackground {black} \
            -selectforeground {gainsboro}

    # pack widget .insp_graph.number.edges
    pack append .insp_graph.number.edges \
            .insp_graph.number.edges.label {left frame center} \
            .insp_graph.number.edges.entry {left frame center expand fillx}

    # pack widget .insp_graph.number
    pack append .insp_graph.number \
            .insp_graph.number.nodes {top frame center expand fillx} \
            .insp_graph.number.edges {top frame center fillx}



    # build widget .insp_graph.type
    frame .insp_graph.type \
            -background {gainsboro} \
            -borderwidth {1} \
            -relief {raised}


    # build widget .insp_graph.type.graph
    frame .insp_graph.type.graph \
            -background {gainsboro} \
            -borderwidth {2}

    # build widget .insp_graph.type.graph.label1
    label .insp_graph.type.graph.label1 \
            -background {gainsboro} \
            -borderwidth {0} \
            -foreground {black} \
            -text {Graph Label:}

    # build widget .insp_graph.type.graph.value
    label .insp_graph.type.graph.value \
            -anchor {w} \
            -background {gainsboro} \
            -foreground {black} \
            -relief {sunken} \
            -text {NONE}

    # build widget .insp_graph.type.graph.menubutton2
    menubutton .insp_graph.type.graph.menubutton2 \
            -background {gainsboro} \
            -foreground {black} \
            -menu {.insp_graph.type.graph.menubutton2.m} \
            -text {v}

    # build widget .insp_graph.type.graph.menubutton2.m
    menu .insp_graph.type.graph.menubutton2.m \
            -background {gainsboro} \
            -foreground {black} 

    # pack widget .insp_graph.type.graph
    pack append .insp_graph.type.graph \
            .insp_graph.type.graph.label1 {left frame center fill} \
            .insp_graph.type.graph.value {left frame center expand fill} \
            .insp_graph.type.graph.menubutton2 {right frame center fill}


    # build widget .insp_graph.type.nodes
    frame .insp_graph.type.nodes \
            -background {gainsboro} \
            -borderwidth {2}

    # build widget .insp_graph.type.nodes.label1
    label .insp_graph.type.nodes.label1 \
            -background {gainsboro} \
            -borderwidth {0} \
            -foreground {black} \
            -text {Node Label: }

    # build widget .insp_graph.type.nodes.value
    label .insp_graph.type.nodes.value \
            -anchor {w} \
            -background {gainsboro} \
            -foreground {black} \
            -relief {sunken} \
            -text {NONE}

    # build widget .insp_graph.type.nodes.menubutton2
    menubutton .insp_graph.type.nodes.menubutton2 \
            -background {gainsboro} \
            -foreground {black} \
            -menu {.insp_graph.type.nodes.menubutton2.m} \
            -text {v}

    # build widget .insp_graph.type.nodes.menubutton2.m
    menu .insp_graph.type.nodes.menubutton2.m \
            -background {gainsboro} \
            -foreground {black} 

    # pack widget .insp_graph.type.nodes
    pack append .insp_graph.type.nodes \
            .insp_graph.type.nodes.label1 {left frame center fill} \
            .insp_graph.type.nodes.value {left frame center expand fill} \
            .insp_graph.type.nodes.menubutton2 {right frame center fill}


    # build widget .insp_graph.type.edges
    frame .insp_graph.type.edges \
            -background {gainsboro} \
            -borderwidth {2}

    # build widget .insp_graph.type.edges.label1
    label .insp_graph.type.edges.label1 \
            -background {gainsboro} \
            -borderwidth {0} \
            -foreground {black} \
            -text {Edge Label: }

    # build widget .insp_graph.type.edges.value
    label .insp_graph.type.edges.value \
            -anchor {w} \
            -background {gainsboro} \
            -foreground {black} \
            -relief {sunken} \
            -text {NONE}

    # build widget .insp_graph.type.edges.menubutton2
    menubutton .insp_graph.type.edges.menubutton2 \
            -background {gainsboro} \
            -foreground {black} \
            -menu {.insp_graph.type.edges.menubutton2.m} \
            -text {v}

    # build widget .insp_graph.type.edges.menubutton2.m
    menu .insp_graph.type.edges.menubutton2.m \
            -background {gainsboro} \
            -foreground {black} 

    # pack widget .insp_graph.type.edges
    pack append .insp_graph.type.edges \
            .insp_graph.type.edges.label1 {left frame center fill} \
            .insp_graph.type.edges.value {left frame center expand fill} \
            .insp_graph.type.edges.menubutton2 {right frame center fill}

    # pack widget .insp_graph.type
    pack append .insp_graph.type \
            .insp_graph.type.graph {top frame center expand fillx} \
            .insp_graph.type.nodes {top frame center expand fillx} \
            .insp_graph.type.edges {top frame center fillx}

    # pack widget .insp_graph
    pack append .insp_graph \
            .insp_graph.number {top frame center expand fill} \
            .insp_graph.type {top frame center expand fill}

    frame .insp_element \
            -borderwidth {1} \
            -relief {raised} 

    frame .insp_element.info \
            -relief {raised}

    frame .insp_element.info.labels 

    label .insp_element.info.current \
            -text {Currently selected}

    label .insp_element.info.labels.name \
            -anchor {w} \
            -width {12}

    label .insp_element.info.labels.color \
            -anchor {w} \
            -width {12}

    pack append .insp_element.info.labels \
            .insp_element.info.labels.name {top frame center fillx} \
            .insp_element.info.labels.color {top frame center fillx}

    frame .insp_element.info.entries

    entry .insp_element.info.entries.name \
            -font {-Adobe-Helvetica-Medium-R-Normal--*-120-*} \
            -relief {ridge}

    entry .insp_element.info.entries.color \
            -font {-Adobe-Helvetica-Medium-R-Normal--*-120-*} \
            -relief {ridge}

    pack append .insp_element.info.entries \
            .insp_element.info.entries.name {top frame center expand fillx} \
            .insp_element.info.entries.color {top frame center expand fillx}
    
    pack append .insp_element.info \
            .insp_element.info.current {top frame center fillx} \
            .insp_element.info.labels {left frame center fill} \
            .insp_element.info.entries {left frame center expand fill}
    
    pack append .insp_element \
            .insp_element.info {top frame center fill} 

    showSyntax 

    # build widget .buttons
    frame .buttons \
            -background {gainsboro} \
            -borderwidth {1}

    # build widget .buttons.special
    frame .buttons.special \
            -background {gainsboro}

    # build widget .buttons.special.dismiss
    button .buttons.special.dismiss \
            -background {gainsboro} \
            -command {recall deleteWindow} \
            -foreground {black} \
            -text {Dismiss}

    # pack widget .buttons.special
    pack append .buttons.special \
            .buttons.special.dismiss {left frame center expand fillx}

    # pack widget .buttons
    pack append .buttons \
            .buttons.special {top frame center expand fillx}
    
    # pack widget .
    pack append . \
            .insp_graph {top frame center expand fill} \
            .insp_element {top frame center expand fill} \
            .buttons {bottom frame center fillx} 

    #  .insp_graph.nodes.number.entry insert end {}
    #  .insp_graph.edges.number.entry insert end {}

    if {"[info procs XFEdit]" != ""} {
        catch "XFMiscBindWidgetTree ."
        after 2 "catch {XFEditSetShowWindows}"
    }
}


# User defined procedures

# Procedure: FillElement
proc FillElement { kind} {
    ###########
    # Procedure: 
    # Author:   Barbara Zuendorf
    # Last Update: 
    #
    # Description: 
    #           
    # Arguments:  
    # Returns: none
    # Sideeffects: none
    ###########
    .insp_element.info.labels.name configure -text "$kind Name:"
    .insp_element.info.labels.color configure -text "$kind Color:"
    .insp_element.syntax.label configure -text "$kind Syntax:"
}


# Procedure: HideElement
proc HideElement {} {
    ###########
    # Procedure: 
    # Author:   Barbara Zuendorf
    # Last Update: 
    #
    # Description: 
    #           
    # Arguments:  
    # Returns: none
    # Sideeffects: none
    ###########
    global insp_element
    pack forget .insp_element.syntax
}


# Procedure: OptionButtonGet
proc OptionButtonGet { widget} {
    
    if {"[winfo class $widget.value]" == "Label"} {
        return [lindex [$widget.value config -text] 4]
    } {
        if {"[winfo class $widget.value]" == "Entry"} {
            return [$widget.value get]
        }
    }
}


# Procedure: OptionButtonSet
proc OptionButtonSet { widget valueWidget} {
    set derText [lindex [$widget entryconfig \
            [$widget index active] -label] 4]

    if {"[winfo class $valueWidget.value]" == "Label"} {
        $valueWidget.value config -text $derText
    } {
        if {"[winfo class $widget.value]" == "Entry"} {
            $valueWidget.value delete 0 end
            $valueWidget.value insert 0 $derText
        }
    }
    recall setMenu $widget $derText
}

# Procedure: addMenu
proc addMenu { widget valueWidget text inspFlag} {
    if {$inspFlag == "NO"} {
        set inspFlag disabled
    } {
        set inspFlag normal
    }

    $widget add command \
            -command "OptionButtonSet $widget $valueWidget" \
            -label $text \
            -state $inspFlag
}

proc addSubMenu { widget newEntry newName} {
    if {[winfo exists $widget.$newEntry] == 0} {
        menu $widget.$newEntry
    }
    $widget add cascade -label $newName -menu $widget.$newEntry
}

proc clearMenu {widget} {
    $widget delete 0 last
}

# Procedure: ShowEdge
proc ShowEdge { name syntax color {type "NONE"}} {
    ###########
    # Procedure: ShowEdge
    # Author:   Barbara Zuendorf
    # Last Update: 21.7.94
    #
    # Description: - calls ShowFrame.insp_elem (if frame does not exist)
    #              - fills the entry and text widgets in window .insp_elem
    #                with information of this edge
    #           
    # Arguments: name - type for which to show informations
    # Returns: none
    # Sideeffects: none
    ###########

    if { $type != "NONE" } {
        pack append .insp_element \
                .insp_element.syntax {top frame center expand fill}
    } {
        pack forget .insp_element.syntax
    }

    FillElement Edge
    
    .insp_element.syntax.buttons.cancel configure -command {
        recall EdgeCancel
    }
    
    .insp_element.syntax.buttons.apply configure -command {
        recall EdgeApply [.insp_element.syntax.frame.text get 1.0 end]
    }
    
    bind .insp_element.info.entries.name <Key-Return> {
        recall EdgeName [%W get]
    }
    bind .insp_element.info.entries.color <Key-Return> {
        recall EdgeColor [%W get]
    }
    bind .insp_element.info.entries.color <Double-Button-3> {
        %W delete 0 end
        set tmpC [ColorBox]
        %W insert insert $tmpC
        recall EdgeColor $tmpC
    }
 
    setName $name
    setColor $color
    setSyntax $syntax
}


# Procedure: showSyntax
proc showSyntax { } {
    ###########
    # Procedure: showSyntax
    # Author:   Barbara Zuendorf
    # Last Update: 15.7.94
    # Description: Builds the frame .insp_element
    # Arguments: none
    # Returns: none
    # Sideeffects: none
    ###########
    frame .insp_element.syntax


    label .insp_element.syntax.label \
            -anchor {w} \
            -text {Syntax:} \
            -width {12}

    frame .insp_element.syntax.frame \
            -relief {raised}

    scrollbar .insp_element.syntax.frame.scrollbar1 \
            -command {.insp_element.syntax.frame.text yview} \
            -relief  {ridge}

    text .insp_element.syntax.frame.text \
            -borderwidth {2} \
            -font {-Adobe-Helvetica-Medium-R-Normal--*-120-*} \
            -height {8} \
            -relief {ridge} \
            -width {40} \
            -wrap {word} \
            -yscrollcommand {.insp_element.syntax.frame.scrollbar1 set}

    # pack widget .insp_element.syntax.frame
    pack append .insp_element.syntax.frame \
            .insp_element.syntax.frame.scrollbar1 {right frame center filly} \
            .insp_element.syntax.frame.text {top frame center expand fill}

    frame .insp_element.syntax.buttons 

    button .insp_element.syntax.buttons.cancel \
            -command {recall "cancel"} \
            -text {Cancel syntax}
    
    button .insp_element.syntax.buttons.apply \
            -command {} \
            -text {Apply syntax}

    pack append .insp_element.syntax.buttons \
            .insp_element.syntax.buttons.apply {left frame center expand fill}\
            .insp_element.syntax.buttons.cancel {left frame center expand fill}

    pack append .insp_element.syntax  \
            .insp_element.syntax.label {left frame nw}\
            .insp_element.syntax.frame {top frame center expand fill} \
            .insp_element.syntax.buttons {bottom frame center fill}

}


# Procedure: ShowGraph
proc ShowGraph { name syntax color {type "NONE"} } {

    if { $type != "NONE" } {
        pack append .insp_element \
                .insp_element.syntax {top frame center expand fill}
    } {
        pack forget .insp_element.syntax
    }

    FillElement Graph
    
    .insp_element.syntax.buttons.cancel configure -command {
        recall GraphCancel
    }
    
    .insp_element.syntax.buttons.apply configure -command {
        recall GraphApply [.insp_element.syntax.frame.text get 1.0 end]
    }
    
    bind .insp_element.info.entries.name <Key-Return> {
        recall GraphName [%W get]
    }
    bind .insp_element.info.entries.color <Key-Return> {
        recall GraphColor [%W get]
    }
    bind .insp_element.info.entries.color <Double-Button-3> {
        %W delete 0 end
        set tmpC [ColorBox]
        %W insert insert $tmpC
        recall GraphColor $tmpC
    }
 
    setName $name
    setColor $color
    setSyntax $syntax
}


# Procedure: ShowNode
proc ShowNode { name syntax color {type "NONE"}} {
    ###########
    # Procedure: ShowNode
    # Author:   Barbara Zuendorf
    # Last Update: 21.7.94
    #
    # Description: - calls ShowFrame.insp_elem (if frame does not exist)
    #              - fills the entry and text widgets in window .insp_elem
    #                with information of this node
    #           
    # Arguments: name - type for which to show informations
    # Returns: none
    # Sideeffects: none
    ###########

    if { $type != "NONE" } {
        pack append .insp_element \
                .insp_element.syntax {top frame center expand fill}
    } {
        pack forget .insp_element.syntax
    }
	
    FillElement Node

    .insp_element.syntax.buttons.cancel configure -command {
        recall NodeCancel
    }
    
    .insp_element.syntax.buttons.apply configure -command {
        recall NodeApply [.insp_element.syntax.frame.text get 1.0 end]
    }

    bind .insp_element.info.entries.name <Key-Return> {
        recall NodeName [%W get]
    }
    bind .insp_element.info.entries.color <Key-Return> {
        recall NodeColor [%W get]
    }
    bind .insp_element.info.entries.color <Double-Button-3> {
        %W delete 0 end
        set tmpC [ColorBox]
        %W insert insert $tmpC
        recall NodeColor $tmpC
    }
    setName $name
    setColor $color
    setSyntax $syntax
}

# Procedure: UpdateGraph
proc UpdateGraph { node_number edge_number} {
    ###########
    # Procedure: UpdateGraph 
    # Author:   Barbara Zuendorf
    # Last Update: 21.7.94
    #
    # Description: sets the node and edge properties of the graph
    #           
    # Arguments:  
    # Returns: none
    # Sideeffects: none
    ###########
    setNumNodes $node_number
    setNumEdges $edge_number
}


# Procedure: setColor
proc setColor { color} {
    .insp_element.info.entries.color delete 0 end
    .insp_element.info.entries.color insert end $color
}

# Procedure: setName
proc setName { name} {
    .insp_element.info.entries.name delete 0 end
    .insp_element.info.entries.name insert end $name
}


# Procedure: setNumEdges
proc setNumEdges { text} {
    .insp_graph.number.edges.entry configure -state normal
    .insp_graph.number.edges.entry delete 0 end
    .insp_graph.number.edges.entry insert end $text
    .insp_graph.number.edges.entry configure -state disabled
}


# Procedure: setNumNodes
proc setNumNodes { text} {
    .insp_graph.number.nodes.entry configure -state normal
    .insp_graph.number.nodes.entry delete 0 end
    .insp_graph.number.nodes.entry insert end $text
    .insp_graph.number.nodes.entry configure -state disabled
}


# Procedure: setSyntax
proc setSyntax { syntax} {
    .insp_element.syntax.frame.text delete 1.0 end
    .insp_element.syntax.frame.text insert insert $syntax
}


# Internal procedures


# initialize global variables
proc InitGlobals {} {
}

# initialize global variables
InitGlobals

# display/remove toplevel windows.
ShowWindow.

# eof
#

