###############################################################################
#
# changeToClass.tcl
# [ansgar] 
# 
# Prozeduren zur Knotendarstellung Box (Label, doubleBox, ...)
#
###############################################################################

global typeArray

# ------------------------------------------------------------
# Procedure: changeToBox
# ndert Knotendarstellung auf Class (Window)

# style: 0:LABEL,  1: BOX,  2: RBOX,  3: DBOX,  4: FBOX

proc changeToBox { item style attrtext icontext {canv "."} } {
    if {$style == "  4"} {
        return [changeToFrameBox $item $attrtext $icontext $canv]
	}

	if {$canv == "." } {
		global symbolicName
		set canv $symbolicName(graphView)
	}
   
	scan [$canv coords $item] {%f %f} x y
	removeItem $canv $item
	#puts "calling changeToClass"
	return [addBoxWindow $canv $style $x $y {green} $attrtext $icontext ]
}


# ------------------------------------------------------------
# procedure: roundrect
# erzeugt abgerundetes Rechteck im bergebenen Canvas
#
proc roundrect {canvas x1 y1 x2 y2 linewidth} {
    set r 10
    set color darkgreen
    $canvas create line [expr $x1+$r] $y1 [expr $x2-$r] $y1\
        -fill $color -width $linewidth
    $canvas create line [expr $x1+$r] $y2 [expr $x2-$r] $y2\
        -fill $color -width $linewidth
    $canvas create line $x1 [expr $y1+$r] $x1 [expr $y2-$r+1]\
        -fill $color -width $linewidth
    $canvas create line $x2 [expr $y1+$r] $x2 [expr $y2-$r+1]\
        -fill $color -width $linewidth
    set r2 [expr $r*2]
    $canvas create arc $x1 [expr $y1+$r2] [expr $x1+$r2] $y1\
        -extent 90 -start 090 -style arc -outline $color -width $linewidth
    $canvas create arc $x2 [expr $y1+$r2] [expr $x2-$r2] $y1\
        -extent 90 -start 000 -style arc -outline $color -width $linewidth
    $canvas create arc $x1 [expr $y2-$r2] [expr $x1+$r2] $y2\
        -extent 90 -start 180 -style arc -outline $color -width $linewidth
    $canvas create arc $x2 [expr $y2-$r2] [expr $x2-$r2] $y2\
        -extent 90 -start 270 -style arc -outline $color -width $linewidth
}


# ------------------------------------------------------------
# Procedure: addBoxWindow
# wandelt Knoten in Class-Darstellung um
# Parameter: Canvas, Postion (x,y), Farbe,
#            Attributtext (Attribute durch NewLine getrennt),
#            Iconattribute (Dateiname, Position, Orientierung)

proc addBoxWindow { canv style x y col attrtext icontext } {
	# Demo-Programm fr Klassendarstellung
	global typeArray

	# -----------------------------------------
	# get width and height of attribute text
	set tmptext $attrtext
	set charcount 0
	set linecount 0
	set cMaxChars 30
	while { [string first "\n" $tmptext] > -1} {
		set ind [string first "\n" $tmptext]
		if { $ind > $charcount } then {
			set charcount $ind
		}
		incr ind
		set tmptext [string range $tmptext $ind end]
		incr linecount
	}
	set ind [string length $tmptext]
	if { $ind > $charcount } then {
		set charcount $ind
	}
	incr charcount
	if { $charcount > $cMaxChars } then {
		set charcount $cMaxChars
    }
	# -----------------------------------------

	# [ansgar] calculate width and height of window
	# use heuristic fontwidth and height
    if {$style == "  0"} {
		set RectangleHeight [expr $linecount * 15]
		set RectangleWidth [expr $charcount * 7+8]
	} else {
		set RectangleHeight [expr $linecount * 15+4]
		set RectangleWidth [expr $charcount * 7+16]
	}
	set boxwidth 1
	
	
	set SubWindowWidth [expr $RectangleWidth + 3 + 2*$boxwidth]
	set SubWindowHeight [expr $RectangleHeight + 3 + 2*$boxwidth]

	# Korrektur der bergebenen x/y-Koordinaten
	set x [expr $x - $boxwidth]
	set y [expr $y - $boxwidth]
	set bg [$canv cget -background]
	set cfTmpTag [$canv create window $x $y\
		-width $SubWindowWidth -height $SubWindowHeight]
	# build widget .frame0
	frame $canv.$cfTmpTag -width $SubWindowWidth -height\
		$SubWindowHeight -background $bg
	# Window Canvas
	canvas $canv.$cfTmpTag.canvas2\
		-closeenough 3.0 -background $bg\
		-insertofftime 600\
		-height $SubWindowHeight -width $SubWindowWidth
 
	pack append $canv.$cfTmpTag $canv.$cfTmpTag.canvas2\
		{top frame center expand fill} 
	frame $canv.$cfTmpTag.canvas2.f1 -bg $bg
 
	#create class canvas
	createBoxCanvas $canv $canv.$cfTmpTag.canvas2.f1 $style\
		$RectangleHeight $RectangleWidth $boxwidth $attrtext


	pack $canv.$cfTmpTag.canvas2.f1 -side top -expand yes -fill both
	$canv itemconfigure $cfTmpTag -window $canv.$cfTmpTag
	bind $canv <Destroy> exit

	# Pfeilspitzen anzeigen
	global isDirected
	set isDirected($canv.$cfTmpTag.canvas2.f1) {YES}

	# verantwortlich fr Rahmen und Moven
	global dragItem
	#set dragItem($canv.$cfTmpTag.canvas2) [$canv.$cfTmpTag.canvas2 create \
                                           rectangle 0 0 0 0]
	#$canv.$cfTmpTag.canvas2 itemconfigure $dragItem($canv.$cfTmpTag.canvas2)\
	#  -outline [$canv.$cfTmpTag.canvas2 cget -bg]  

	# Bindings  
	global currentNode
	global node_B1_press node_B1_shift_press node_B1_motion node_B1_release
	global node_B3_press node_B3_shift_press node_B3_motion node_B3_release
	set currentNode $cfTmpTag

	# Selektierung
	$node_B1_press $canv.$cfTmpTag.canvas2.f1 $cfTmpTag $currentNode
	$node_B1_press $canv.$cfTmpTag.canvas2.f1.canv3 $cfTmpTag $currentNode
	$node_B1_shift_press $canv.$cfTmpTag.canvas2.f1 $cfTmpTag $currentNode
	$node_B1_shift_press $canv.$cfTmpTag.canvas2.f1.canv3 $cfTmpTag $currentNode

	# Bewegen des Fensters
	# beachte: benutze absolute Screen-Koordinaten %X und %Y
	$node_B1_motion $canv.$cfTmpTag.canvas2.f1
	$node_B1_motion $canv.$cfTmpTag.canvas2.f1.canv3

	# Menu anzeigen
	# Menu wird absolut auf dem Screen plaziert - ist kein
	# ChildWindow des Canvas!
	$node_B3_press $canv.$cfTmpTag.canvas2.f1.canv3 $cfTmpTag
	$node_B3_shift_press $canv.$cfTmpTag.canvas2.f1.canv3 $cfTmpTag
	# Menu entfernen
	$node_B3_release $canv.$cfTmpTag.canvas2.f1.canv3
	$node_B1_release $canv.$cfTmpTag.canvas2.f1.canv3
	# Menupunkt auswhlen
	$node_B3_motion $canv.$cfTmpTag.canvas2.f1.canv3 $cfTmpTag

	# Tag hinzufgen - wird fr Bewegen des Fensters etc. bentigt
	$canv addtag classNode withtag $cfTmpTag
	# Bindings des Canvas durchfhren
	addCanvasBindings $canv

	$canv addtag nodetag withtag $cfTmpTag

	# cfTmpTag fr alle neuen Darstellungsformen setzen - sonst gibt es einen
	# Segmentation Fault bei Anklicken eines Knotens in dieser Darstellung!
	set cfTmpTag "$canv.$cfTmpTag.canvas2 $cfTmpTag"
 
	return $cfTmpTag
}


# ------------------------------------------------------------

proc createBoxCanvas { canv c style RectangleHeight RectangleWidth\
		boxwidth attrtext} {
	#

	#set boxwidth 2
	set SubWindowWidth [expr $RectangleWidth + 2*$boxwidth]
	set SubWindowHeight [expr $RectangleHeight + 2*$boxwidth]


	#set dashStyle ""

	# Window Canvas
	set bg [$canv cget -background]
	canvas $c.canv3\
		-closeenough 3.0 -background $bg\
		-insertofftime 600\
		-height $SubWindowHeight -width $SubWindowWidth\
		-highlightbackground $bg
	set canv3 $c.canv3
	pack $canv3 -side top -expand yes -fill both

	set x1 [expr $boxwidth+1]
	set y1 [expr $boxwidth+1]
	set x2 [expr $RectangleWidth+1+$boxwidth]
	set y2 [expr $RectangleHeight+1+$boxwidth]

	set cFontName Helvetica
	set cFontSize 12         ;# 11 / 12 / 14 / 17
	set cFontState *         ;# Bold / Medium
	set cFontRegular r       ;# R / O
	set FontClass "-*-$cFontName-$cFontState-$cFontRegular-Normal--$cFontSize-*-*"

	$canv3 create text\
		[expr $boxwidth+ $RectangleWidth/2]\
		[expr $RectangleHeight/2 + 10]\
		-text $attrtext -width [expr $RectangleWidth-10]\
		-font $FontClass -justify center
	#$canv3 create rect 0 0 20 20 -outline black

	# DBOX?
    if {$style == "  3"} {
		$canv3 create rectangle $x1 $x1 $x2 $y2 -width $boxwidth
		set x [expr $x1+2*$boxwidth]
		$canv3 create line $x $y1 $x $y2 -width $boxwidth
		set x [expr $x2-2*$boxwidth]
		$canv3 create line $x $y1 $x $y2 -width $boxwidth
	}

	# RBOX?
    if {$style == "  2"} {
		roundrect $canv3 $x1 $y1 $x2 $y2 $boxwidth
	}

	# BOX?
    if {$style == "  1"} {
		$canv3 create rectangle $x1 $x1 $x2 $y2 -width $boxwidth
	}

	pack $canv3
	return $canv3
}

return ok
