###############################################################################
#
# changeToCircle.tcl
# 
# 
# Prozeduren zur Knotendarstellung CIRCLE
# 
# Procedure: changeToCircle
# Change current style of node to circle
# 
# Procedure: addCircleNode
# draw node as circle
#
###############################################################################


# Procedure: changeToCircle
# Change current style of node to circle
proc changeToCircle {item {col black} {canv "."}} {
    if {$canv == "."} {
        global symbolicName
        set canv [set symbolicName(graphView)]
    }
    
    focus $canv

    # change only if not already circle
    if {[lsearch [$canv gettags $item] circleNode] != -1} {
        return ""
    } {
	# remove node
        scan [$canv coords $item] {%f %f} x y
        removeItem $canv $item
	# add node as circle
        return [addCircleNode $canv $x $y 15 $col ]
    }
}


# Procedure: addCircleNode
# draw node as circle
proc addCircleNode { canv x y r col } {
    set cfTmpTag [$canv create oval [expr ($x-$r)] [expr ($y+$r)] [expr ($x+$r)] [expr ($y-$r)]] 
    $canv itemconfigure $cfTmpTag -fill $col -outline $col -width {3}

    # set tag to circle for identifying style
    $canv addtag circleNode withtag $cfTmpTag  
    $canv addtag nodetag withtag $cfTmpTag

    # bind standard events to node
    addNodeBindings $canv $cfTmpTag

    return $cfTmpTag
}


return ok