###############################################################################
#
# changeToClass.tcl
# 
# 
# Prozeduren zur Knotendarstellung CLASS
#
###############################################################################

global typeArray


# Procedure: changeToClass
# aendert Knotendarstellung auf Class (Window)
proc changeToClass { item attrtext icontext {canv "."} } {
    if {$canv == "." } {
        global symbolicName
        set canv $symbolicName(graphView)
    }
    
      scan [$canv coords $item] {%f %f} x y
      removeItem $canv $item
      #puts "calling changeToClass"
      return [addClassWindow $canv $x $y {green} $attrtext $icontext ]
}

# Procedure: addClassWindow
# wandelt Knoten in Class-Darstellung um
# Parameter: Canvas, Postion (x,y), Farbe,
#            Attributtext (Attribute durch NewLine getrennt),
#            Iconattribute (Dateiname, Position, Orientierung)

proc addClassWindow { canv x y col attrtext icontext } {
# Demo-Programm fuer Klassendarstellung
  global typeArray

  catch {set Attributes $typeArray(CLASSATTRIBUTES) ; return 0 } error_code
  if { $error_code != 0 } then { 
      puts "addClassWindow: typeArray undefined"
      set Attributes 0
  }
  catch {set Operations $typeArray(CLASSOPERATIONS) ; return 0 } error_code
  if { $error_code != 0 } then { 
      puts "addClassWindow: typeArray undefined"
      set Operations 0
  }
  
  catch {set SectionHeight $typeArray(CLASSHEIGHT) ; return 0 } error_code
  if { $error_code != 0 } then { 
      puts "addClassWindow: typeArray undefined"
      set SectionHeight 50
  }
  set sections [expr 1+$Attributes+$Operations]

  catch {set RectangleWidth $typeArray(CLASSWIDTH) ; return 0 } error_code
  if { $error_code != 0 } then { 
      puts "addClassWindow: typeArray undefined"
      set RectangleWidth 150
  }
  set RectangleHeight [expr $SectionHeight*$sections]

  catch {set boxwidth $typeArray(CLASSSTRENGTH) ; return 0 } error_code
  if { $error_code != 0 } then { 
      puts "addClassWindow: typeArray undefined"
      set boxwidth 2
  }
  set SubWindowWidth [expr $RectangleWidth + 3 + 2*$boxwidth]
  set SubWindowHeight [expr $RectangleHeight + 3 + 2*$boxwidth]

  # Fehlerkorrektur der uebergebenen x/y-Koordinaten - Grund des Fehlers?
  set x [expr $x - $boxwidth]
  set y [expr $y - $boxwidth]
  set cfTmpTag [$canv create window $x $y -width $SubWindowWidth -height $SubWindowHeight ]
  # build widget .frame0
  frame $canv.$cfTmpTag -width $SubWindowWidth -height $SubWindowHeight -bg {black}
  # Window Canvas
  canvas $canv.$cfTmpTag.canvas2 \
      -closeenough {3.0} -bg {lightgrey} \
    -insertbackground {black} -insertofftime {600} \
    -selectbackground {black} -selectforeground {gainsboro} \
    -height $SubWindowHeight -width $SubWindowWidth 
 
  pack append $canv.$cfTmpTag $canv.$cfTmpTag.canvas2 {top frame center expand fill} 
  frame $canv.$cfTmpTag.canvas2.f1 -bg {black}
 
  #create class canvas
  set c $canv.$cfTmpTag.canvas2.f1
  set cc [createClassCanvas $c $SectionHeight $RectangleWidth $boxwidth $Attributes $Operations $attrtext]


  pack $canv.$cfTmpTag.canvas2.f1 -side top -expand yes -fill both
#  $canv.$cfTmpTag.canvas2.f1 configure -bg #ebebeb
  $canv itemconfigure $cfTmpTag -window $canv.$cfTmpTag
  bind $canv <Destroy> exit

  # Pfeilspitzen anzeigen
  global isDirected
  set isDirected($canv.$cfTmpTag.canvas2.f1) {YES}
    
  # verantwortlich fuer Rahmen und Moven
  global dragItem
  set dragItem($canv.$cfTmpTag.canvas2) [$canv.$cfTmpTag.canvas2 create \
                                           rectangle 0 0 0 0]
  $canv.$cfTmpTag.canvas2 itemconfigure $dragItem($canv.$cfTmpTag.canvas2)\
    -outline [$canv.$cfTmpTag.canvas2 cget -bg]  

# Bindings  
  global currentNode
  global node_B1_press node_B1_shift_press node_B1_motion node_B1_release
  global node_B3_press node_B3_shift_press node_B3_motion node_B3_release
  set currentNode $cfTmpTag

# Selektierung - tut so wie es ist - wer weiss wieso
  $node_B1_press $canv.$cfTmpTag.canvas2.f1 $cfTmpTag $currentNode
  $node_B1_press $canv.$cfTmpTag.canvas2.f1.canv3 $cfTmpTag $currentNode
  $node_B1_shift_press $canv.$cfTmpTag.canvas2.f1 $cfTmpTag $currentNode
  $node_B1_shift_press $canv.$cfTmpTag.canvas2.f1.canv3 $cfTmpTag $currentNode

# Bewegen des Fensters
  # beachte: benutze absolute Screen-Koordinaten %X und %Y
  $node_B1_motion $canv.$cfTmpTag.canvas2.f1
  $node_B1_motion $canv.$cfTmpTag.canvas2.f1.canv3

# Menu anzeigen
  # Menu wird absolut auf dem Screen plaziert -  ist kein ChildWindow des Canvas!
  $node_B3_press $canv.$cfTmpTag.canvas2.f1.canv3 $cfTmpTag
  $node_B3_shift_press $canv.$cfTmpTag.canvas2.f1.canv3 $cfTmpTag
# Menu entfernen
  $node_B3_release $canv.$cfTmpTag.canvas2.f1.canv3
  $node_B1_release $canv.$cfTmpTag.canvas2.f1.canv3
# Menupunkt auswaehlen
  $node_B3_motion $canv.$cfTmpTag.canvas2.f1.canv3 $cfTmpTag

# Tag hinzufuegen - wird fuer Bewegen des Fensters etc. benoetigt
  $canv addtag classNode withtag $cfTmpTag
# Bindings des Canvas durchfuehren
  addCanvasBindings $canv

  $canv addtag nodetag withtag $cfTmpTag

  # cfTmpTag fuer alle neuen Darstellungsformen setzen - sonst gibts Segmentation Fault bei Anklicken eines Knotens in dieser Darstellung !!!
  set cfTmpTag "$canv.$cfTmpTag.canvas2 $cfTmpTag"
 
  return $cfTmpTag
}


proc createClassCanvas { c SectionHeight RectangleWidth boxwidth Attributes Operations attrtext} {
#to do: fuer jede Section eigene Hoehe errechnen (gemaess Text Attribute/Operationen)

  #set SectionHeight 50
  set sections [expr 1+$Attributes+$Operations]
    
  #set RectangleWidth 150
  set RectangleHeight [expr $SectionHeight*$sections]

  #set boxwidth 2
  set SubWindowWidth [expr $RectangleWidth + 2*$boxwidth]
  set SubWindowHeight [expr $RectangleHeight + 2*$boxwidth]


  #set dashStyle ""

  # Window Canvas
  canvas $c.canv3 \
      -closeenough {3.0} -bg {gainsboro} \
    -insertbackground {black} -insertofftime {600} \
    -selectbackground {black} -selectforeground {gainsboro} \
    -height $SubWindowHeight -width $SubWindowWidth 
# -bg #ebebeb
  set canv3 $c.canv3
    set x1 [expr $boxwidth+1]
    set x2 [expr $RectangleWidth+1+$boxwidth]
    set y2 [expr $RectangleHeight+1+$boxwidth]
#  $canv create rectangle $boxwidth $boxwidth [expr $RectangleWidth+1+$boxwidth] [expr $RectangleHeight+1+$boxwidth] -width $boxwidth -dash $dashStyle
#  $canv3 create rectangle $boxwidth $boxwidth [expr $RectangleWidth+1+$boxwidth] [expr $RectangleHeight+1+$boxwidth] -width $boxwidth
    $canv3 create rectangle $x1 $x1 $x2 $y2 -width $boxwidth
  if {$Attributes == 1} {
    $canv3 create line $x1 $SectionHeight $x2 $SectionHeight -width $boxwidth -fill black
    if {$Operations == 1} {
	$canv3 create line $x1 [expr $SectionHeight*2] $x2  [expr $SectionHeight*2] -width $boxwidth -fill black
      }
  } else {
    if {$Operations == 1} {
      $canv3 create line $x1 [expr $RectangleHeight/$sections - 5]  $x2  [expr $RectangleHeight/$sections - 5] -width $boxwidth -fill black
      $canv3 create line $x1 [expr $RectangleHeight/$sections + 5]  $x2  [expr $RectangleHeight/$sections + 5] -width $boxwidth -fill black
    }
  }

  set cFontName Courier
  set cFontSize 14         ;# 11 / 12 / 14 / 17
  set cFontSize2 12         ;# 11 / 12 / 14 / 17
  set cFontState *         ;# Bold / Medium
  set cFontRegular r       ;# R / O
  set FontClass "-*-$cFontName-$cFontState-$cFontRegular-Normal--$cFontSize-*-*"
  set FontAttrib "-*-$cFontName-$cFontState-$cFontRegular-Normal--$cFontSize2-*-*"

  $canv3 create text [expr $boxwidth+ $RectangleWidth/2] [expr $SectionHeight/2 + 10] -text $attrtext -width [expr $RectangleWidth-10] -font $FontClass -justify center

  if {$Attributes == 1} {
#    $canv3 create text [expr $boxwidth+ $RectangleWidth/2] [expr $SectionHeight/2 + $SectionHeight]  -text "Attr1: Test\nAttr2: Nochn Test" -width [expr $RectangleWidth-10] -font $FontAttrib -justify center
    $canv3 create text [expr $boxwidth+ $RectangleWidth/2] [expr $SectionHeight/2 + $SectionHeight]  -text " " -width [expr $RectangleWidth-10] -font $FontAttrib -justify center
  }
  if {$Operations == 1} {
#      $canv3 create text [expr $boxwidth+ $RectangleWidth/2] [expr $SectionHeight/2 + $SectionHeight*[expr $sections-1]]  -text "Operation1: Test\nOperation2: Nochn Test" -width [expr $RectangleWidth-10] -font $FontAttrib -justify center
      $canv3 create text [expr $boxwidth+ $RectangleWidth/2] [expr $SectionHeight/2 + $SectionHeight*[expr $sections-1]]  -text " " -width [expr $RectangleWidth-10] -font $FontAttrib -justify center
  }

  pack $canv3

  return $canv3
}

return ok
