###############################################################################
#
# changeToDot.tcl
# 
# 
# Prozeduren zur Knotendarstellung DOT
#
# Procedure: changeToDot
# aendert Knotendarstellung auf Dot (kleiner Circle)
#
# Procedure: addDotNode
# zeichnet Knoten in Dot-Darstellung
#
###############################################################################


# Procedure: changeToDot
# aendert Knotendarstellung auf Dot (kleiner Circle)
proc changeToDot { item {canv "."} } {
    global typeArray

    if {$canv == "." } {
        global symbolicName
        set canv $symbolicName(graphView)
    }
    
    focus $canv

#    if {[lsearch [$canv gettags $item] dotNode] != -1} {
#	puts "changeToDot: no dotnode found"
#        return ""
#    } {
#	puts "changeToDot: dotnode found"
	scan [$canv coords $item] {%f %f} x y
#	puts "changeToDot: dotnode scanned"
	removeItem $canv $item
#	puts "changeToDot: dotnode removed"
	return [addDotNode $canv [expr $x] [expr $y] $typeArray(DOTRADIUS) {black}]
	#      return [addDotNode $canv $x $y 1 {black}]
#    }
}

# Procedure: addDotNode
# wandelt Knoten in Dot-Darstellung um
# Parameter: Canvas, Postion (x,y), Radius
proc addDotNode { canv x y r col } {

  # Fehlerkorrektur der uebergebenen x/y-Koordinaten - Grund des Fehlers?
#  set x [expr $x + 10]
#  set y [expr $y + 10]

#  puts "addDotNode: radius $r [expr ($x+$r)] [expr ($y-$r)] [expr ($x-$r)] [expr ($y+$r)] "

  set cfTmpTag [$canv create oval [expr ($x-$r)] [expr ($y-$r)] [expr ($x+$r)] [expr ($y+$r)]] 
  $canv itemconfigure $cfTmpTag -fill $col
#  $canv itemconfigure $cfTmpTag -fill $col -outline $col -width $r

  $canv addtag nodetag withtag $cfTmpTag
  $canv addtag dotNode withtag $cfTmpTag
  addNodeBindings $canv $cfTmpTag

  # cfTmpTag fuer alle neuen Darstellungsformen setzen - sonst gibts Segmentation Fault bei Anklicken eines Knotens in dieser Darstellung !!!
  set cfTmpTag "$canv.$cfTmpTag.canvas2 $cfTmpTag"
 
  return $cfTmpTag
}

return ok