###############################################################################
#
# changeToPackage.tcl
# 
# 
# Prozeduren zur Knotendarstellung PACKAGE
#
###############################################################################


# Procedure: changeToPackage
# aendert Knotendarstellung auf Package (Window)
proc changeToPackage { item attrtext icontext {canv "."} } {
    if {$canv == "." } {
        global symbolicName
        set canv $symbolicName(graphView)
    }
    
      scan [$canv coords $item] {%f %f} x y
      removeItem $canv $item
      return [addPackageWindow $canv $x $y {green} $attrtext $icontext ]
}

# Procedure: addPackageWindow
# wandelt Knoten in Package-Darstellung um
# Parameter: Canvas, Postion (x,y), Farbe,
#            Attributtext (Attribute durch NewLine getrennt),
#            Iconattribute (Dateiname, Position, Orientierung)
proc addPackageWindow { canv x y col attrtext icontext } {

  # Fontdaten - eventuell spaeter konfigurierbar
  set cFontName Courier
  set cFontSize 11         ;# 11 / 12 / 14 / 17
  set cFontState *         ;# Bold / Medium
  set cFontRegular r       ;# R / O
  set FontDefault "-*-$cFontName-$cFontState-$cFontRegular-Normal--$cFontSize-*-*"
  set cMaxChars 30     ;# max. erlaubte Zeilenlaenge - default 30

  # berechnete Werte
  set charcount 1      ;# max. Textzeilenlaenge
  set linecount 1      ;# Zeilenanzahl

  # ueberfluessige Leerzeichen loeschen  
  set attrtext [string trim $attrtext]
  set icontext [string trim $icontext]

    set FontData $FontDefault
    set cCharHeight 13  
    set cCharWidth 7   
 
  if { $attrtext == "" } then {
    set attrIsVisible false
  } else {
    set attrIsVisible true
  }

  # testweise feste Groesse
  set SubWindowHeight 100
  set SubWindowWidth 100
    
  # Fehlerkorrektur der uebergebenen x/y-Koordinaten - Grund des Fehlers?
  set x [expr $x + 10]
  set y [expr $y + 10]
  # Fenster erstellen
  set cfTmpTag [$canv create window $x $y -width $SubWindowWidth -height $SubWindowHeight ]
  
  # Window Border
  #frame $canv.$cfTmpTag \
  #  -bd {3} -bg {lightgrey} -relief {ridge} \
  # -width $SubWindowWidth -height $SubWindowHeight

  frame $canv.$cfTmpTag -bd {1} -bg #ebebeb \
    -width $SubWindowWidth -height $SubWindowHeight
  
  # Window Canvas
  canvas $canv.$cfTmpTag.canvas2 \
    -bg #ebebeb -closeenough {3.0} \
    -insertbackground {black} -insertofftime {600} \
    -relief {sunken} -selectbackground {black} \
    -selectforeground {gainsboro} \
    -height $SubWindowHeight -width $SubWindowWidth 
 
  pack append $canv.$cfTmpTag $canv.$cfTmpTag.canvas2 {top frame center expand fill} 
  #frame $canv.$cfTmpTag.canvas2.f1 -bd 1 -relief groove -height 1
  frame $canv.$cfTmpTag.canvas2.f1 -height 1 -bg #ebebeb
 
  #create notebook
  set c $canv.$cfTmpTag.canvas2.f1
  set n [CreateNoteBook $c nb $attrtext 99 99 0 $FontData]


  pack $canv.$cfTmpTag.canvas2.f1 -side top -expand yes -fill both
  $canv.$cfTmpTag.canvas2.f1 configure -bg #ebebeb
  $canv itemconfigure $cfTmpTag -window $canv.$cfTmpTag
  bind $canv <Destroy> exit
     
  # Pfeilspitzen anzeigen
  global isDirected
  set isDirected($canv.$cfTmpTag.canvas2) {YES}
    
  # verantwortlich fuer Rahmen und Moven
  global dragItem
  set dragItem($canv.$cfTmpTag.canvas2) [$canv.$cfTmpTag.canvas2 create \
                                           rectangle 0 0 0 0]
  $canv.$cfTmpTag.canvas2 itemconfigure $dragItem($canv.$cfTmpTag.canvas2)\
    -outline [$canv.$cfTmpTag.canvas2 cget -bg]  

# Bindings  
  global currentNode
  global node_B1_press node_B1_shift_press node_B1_motion node_B1_release
  global node_B3_press node_B3_shift_press node_B3_motion node_B3_release
  set currentNode $cfTmpTag

# Selektierung - tut so wie es ist - wer weiss wieso
  # notebook frame
  set nbf [$canv.$cfTmpTag.canvas2.f1.$n subwidget nbframe]
  # notebook page
  set nbp [$canv.$cfTmpTag.canvas2.f1.$n subwidget page1]
  $node_B1_press $canv.$cfTmpTag.canvas2.f1 $cfTmpTag $currentNode
  $node_B1_press $nbp $cfTmpTag $currentNode

  $node_B1_shift_press $canv.$cfTmpTag.canvas2.f1 $cfTmpTag $currentNode
  $node_B1_shift_press $nbp $cfTmpTag $currentNode

# Bewegen des Fensters
  # beachte: benutze absolute Screen-Koordinaten %X und %Y
  $node_B1_motion $canv.$cfTmpTag.canvas2.f1
  $node_B1_motion $nbp

# Menu anzeigen
  # Menu wird absolut auf dem Screen plaziert -  ist kein ChildWindow des Canvas!
  $node_B3_press $canv.$cfTmpTag.canvas2.f1 $cfTmpTag
  $node_B3_press $nbp $cfTmpTag
  $node_B3_press $nbf $cfTmpTag

# Info in Statusbar anzeigen
  $node_B3_shift_press $canv.$cfTmpTag.canvas2.f1 $cfTmpTag
  $node_B3_shift_press $nbp $cfTmpTag
  $node_B3_shift_press $nbf $cfTmpTag

# Menu verstecken - fuer TixPopup disabled
  $node_B3_release $canv.$cfTmpTag.canvas2.f1
  $node_B3_release $nbp
  $node_B3_release $nbf
  $node_B1_release $canv.$cfTmpTag.canvas2.f1
  $node_B1_release $nbp
  $node_B1_release $nbf

# Menupunkt auswaehlen - fuer TixPopup disabled
  $node_B3_motion $canv.$cfTmpTag.canvas2.f1 $cfTmpTag
  $node_B3_motion $nbp $cfTmpTag
  $node_B3_motion $nbf $cfTmpTag
  
  $canv addtag packageNode withtag $cfTmpTag  ;# wird fuer Bewegen des Fensters etc. benoetigt
  addCanvasBindings $canv                    ;# Bindings des Canvas durchfuehren


  $canv addtag nodetag withtag $cfTmpTag

  # cfTmpTag fuer alle neuen Darstellungsformen setzen - sonst gibts Segmentation Fault bei Anklicken eines Knotens in dieser Darstellung !!!
  set cfTmpTag "$canv.$cfTmpTag.canvas2 $cfTmpTag"
 
  return $cfTmpTag
}


proc CreateNoteBook {c nb Labeltext nbwidth nbheight scrolls FontData} {

    # Create the notebook widget and set its backpagecolor to gray.
    # Note that the -backpagecolor option belongs to the "nbframe"
    # subwidget.
    
#    tixNoteBook $c.$nb -ipadx 1 -ipady 1 -width $nbwidth -height $nbheight
    tixNoteBook $c.$nb -width $nbwidth -height $nbheight
    $c config -bg {gainsboro}
    $c.$nb subwidget nbframe config -backpagecolor #ebebeb -font $FontData
    

    #$w.nb add page1 -label "Package" -underline 0
    #pack $c.$nb -expand yes -fill both -padx 5 -pady 5 -side top

    $c.$nb add page1 -label $Labeltext
#    pack $c.$nb -padx 1 -pady 2 -side top
    pack $c.$nb -side top
    
    # Create the first page
    set f [$c.$nb subwidget page1]

    # Create one frame
    frame $f.common
    pack $f.common -side right

    # Create the controls that only belong to this page
    #set n [CreateCanvas $f $scrolls]

    return $nb
}

proc CreateCanvas {x scrolls} {

  if {$scrolls == 0} then {
      	canvas $x.canv -background {white} -relief {raised} \
        	-height {20} -width {30} 

    	pack append $x $x.canv {top frame center} 
    } else {
      	canvas $x.canv -background {white} -relief {raised} \
        	-height {200} -width {300} \
    		-xscrollcommand {.demo.canv.nb.nbframe.page1.scrollbar2 set} \
    		-yscrollcommand {.demo.canv.nb.nbframe.page1.scrollbar1 set}

  	scrollbar $x.scrollbar1 \
      		-command {.demo.canv.nb.nbframe.page1.canv yview} -bg {gold} -relief {raised}
  	scrollbar $x.scrollbar2 \
		-command {.demo.canv.nb.nbframe.page1.canv xview} -bg {gold} -orient {horizontal} -relief {raised}

    	pack append $x \
        	$x.scrollbar1 {right frame center filly} \
        	$x.canv {top frame center} \
        	$x.scrollbar2 {top frame center fillx}
        	
        $x.canv configure -height 12c -width 30c
        pack $x.canv 	  
 	    }
    
    return $x.canv
 }

return ok