#

proc stringDELETE {search in} {
    while {[set pos [string first $search $in]] != -1} {
	set before [string range $in 0 [expr $pos-1]]
	set pos [expr $pos +[string length $search] ]
	set after  [string range $in $pos end]
	set in $before$after
    }
    return $in
}


proc stringDeleteLast {search in} {
    if {[set pos [string last $search $in]] != -1} {
	set before [string range $in 0 [expr $pos-1]]
	set pos [expr $pos +[string length $search] ]
	set after  [string range $in $pos end]
	set in $before$after
    }
    return $in
}

# wurde ein conf- file mitangegeben und existiert es ?
if {[file exist $argv] == 1 } {
    set conf [open $argv]
} else {
    set conf ""
}


# GENDIR gesetzt ? - sonst defaulten
if {[string first "GENDIR" [array names env]] != -1} {
    cd $env(GENDIR)
} else {
    cd $env(HOME)/prototypes
}

# "...UIInit._c" lesen und im speicher aendern 
set UIInitName [glob *UIInit.*c]
set UIInit [open $UIInitName]
set  text [read $UIInit]
set text [stringDELETE "Tcl_Interp *interp" $text]
set text [stringDELETE "interp," $text ]
close $UIInit
# rausschreiben
set UIInit [open $UIInitName w+]
puts $UIInit $text
close  $UIInit

# wenn "config.ecu" existiert, wurde schon prepariert
if {[file exist "config.ecu"] == 1 } {
    puts stdout "already prepared (config.ecu exists)"
    exit
}

set menu [open menu.tcl]
set out  [open out w+]

# Kommentareintrag in "config.ecu"
puts $out "# each progres operation is represented by one line"
puts $out "# each line has two entries"
puts $out "# the 1st one is for system use only and refers to a progres operation - do NOT modify"
puts $out "# the 2nd is the user defined menu entry (don`t use spaces)"
puts $out "# don`t use menu entries twice"
puts $out " "

# Std. Eintraege fuer undo(all) redo:
puts $out "MENU Undo {"
puts $out "Undo Undo"
puts $out "UndoAll UndoAll"
puts $out "Redo Redo"
puts $out "}\n"

# Menus zusammenbasteln
if {$conf != "" } {
    puts stdout "using file $argv for menu preparation ..."
    set line ""
    while {[gets $conf line] != -1} {
	set prefix [string range $line 0 [expr [string first " " $line]-1]]
	set name   [string range $line [expr [string first " " $line]+1] end]
	puts $out "MENU $name {"
	seek $menu 0
	set menuline ""
	while {[gets $menu menuline] != -1} {
            set menuline [string trim $menuline]
            if {[string compare $menuline ""] ==  0} { continue }
            if {[string first "#" $menuline ] ==  0} { continue }
	    if {[string first $prefix $menuline] != -1 } { 
		if { [string first $prefix $menuline] !=  [string last $prefix $menuline] } {
		    set menuline [stringDeleteLast $prefix $menuline]
		}
		if {[string first "menutool addmenu Transactions " $menuline] != -1 } {
                  set menuline [string range $menuline 30 end] 
                }
		if {[string compare $line ""] !=  0} { 
		    puts $out $menuline
		}
	    }
	}
	puts $out "}\n"
    }
    close $conf
} else {
    puts stdout "doing default menu preparation ..."
    set menu [open "menu.tcl"]
    puts $out "MENU Transactions {"
    set line ""
    while { [gets $menu line] != -1 } {
	set line [string trim $line]
	if {[string compare $line ""] ==  0} { continue }
	if {[string first "#" $line ] ==  0} { continue }
	if {[string first "menutool addmenu Transactions " $line] != -1 } {
          set line [string range $line 30 end]  
        }
	puts $out $line
    }
    puts $out "}\n"
}

close $menu
close $out

file copy -force out config.ecu
file delete -force out

puts stdout "files prepared.\ngood luck for compiling ...\n"
exit
