###############################################################################
#
# setNodeStyleBox.tcl
# 
# 
# Erzeugung des Rahmens fuer NodeStyle Box
#
#
###############################################################################

proc create_box_style { } {
    global typeArray
    global typeList
    global actualType
    global nodeStyle
    global h1
    global h2
    global c1
    global c2
    global c3
    global visi_value
    global main_window
    global nodeLabel
    global edgelabel
    global iconposition
    global win_path_for_types
    global win_path_for_tree
    global win_path_for_shape
    global wtextfont
    global wtextsize
    global win_path_for_font
    global boxFont
    global allAttr

    #--------------------------------------------------------------
    # Fenster fuer Tab NodeStyle ermitteln
    #--------------------------------------------------------------
    set w $win_path_for_shape.top.frNodeShape.right.frStyles

    if { [winfo exists $w.right] == 1  } { destroy $w.right }
    
    #--------------------------------------------------------------
    # Rahmen fuer die rechte Seite
    #--------------------------------------------------------------
    frame $w.right
    pack $w.right -side top -fill both -expand yes

    set right $w.right

    #--------------------------------------------------------------
    # Ueberschrift
    #--------------------------------------------------------------
    label $right.label1 -text "Shape Specific Options" -fg blue
    pack $right.label1 -side top -padx 2

    #--------------------------------------------------------------
    # Icon Attribut
    #--------------------------------------------------------------
    tixComboBox $right.iconAttr -label "Icon Attribute:" -dropdown true \
	-command iconAttr:select_attr -editable false  \
	-options { listbox.height 8   label.width 16   label.anchor w }

    foreach attr $allAttr { $right.iconAttr insert end $attr }
    tixSetSilent $right.iconAttr $typeArray(ICONATTR);
    pack $right.iconAttr  -side top -anchor w
    
    #--------------------------------------------------------------
    # Option Icon Position
    #--------------------------------------------------------------
    tixOptionMenu $right.iconposition -label "Icon Position:" \
	-variable iconposition\
	-command iconposition:set \
	-options { label.width 16   label.anchor w   menubutton.width 15 }
    pack $right.iconposition -side top -padx 2 -anchor w
    $right.iconposition add command $typeArray(ACTUALICONPOSITION) -label $typeArray(ACTUALICONPOSITION)
    foreach pos $typeArray(ICONPOSITION)  {
	if { [string compare  $typeArray(ACTUALICONPOSITION) $pos] != 0 } { $right.iconposition add command $pos -label $pos }
    }
    
}

proc iconAttr:select_attr { selection } {
    #--------------------------------------------------------------
    # Icon-Attribut speichern
    #--------------------------------------------------------------
    global typeArray
    set typeArray(ICONATTR) $selection
}

proc iconposition:set { sel } {
    #--------------------------------------------------------------
    # Icon-Position speichern
    #--------------------------------------------------------------
    global typeArray
    set  typeArray(ACTUALICONPOSITION) $sel
}

return ok