###############################################################################
#
# setNodeStyleClass.tcl
# 
# 
# Erzeugung des Rahmens fuer NodeStyle Class
#
#
###############################################################################

proc create_class_style {} {
    global typeArray
    global typeList
    global actualType
    global nodeStyle
    global h1
    global h2
    global c1
    global c2
    global c3
    global visi_value
    global main_window
    global nodeLabel
    global edgelabel
    global iconposition
    global win_path_for_types
    global win_path_for_tree
    global win_path_for_shape
    global wtextfont
    global wtextsize
    global win_path_for_font
    global classFont
    global classAttributes
    global classOperations
    global classVisibility
    global classVisiSymbol
    global classStereotype
    global nClassStrength
    global nClassWidth
    global nClassHeight

    #--------------------------------------------------------------
    # Fenster des Tabs ermitteln
    #--------------------------------------------------------------
    set w $win_path_for_shape.top.frNodeShape.right.frStyles

    if { [winfo exists $w.right] == 1  } { destroy $w.right }
    
    #--------------------------------------------------------------
    # Rahmen fuer die rechte Seite
    #--------------------------------------------------------------
    frame $w.right
    pack $w.right -side top -fill both -expand yes

    set right $w.right

    #--------------------------------------------------------------
    # Ueberschrift
    #--------------------------------------------------------------
    label $right.label1 -text "Shape Specific Options" -fg blue
    pack $right.label1 -side top -padx 2

    #--------------------------------------------------------------
    # Frames erstellen
    #--------------------------------------------------------------
    frame $right.frame1
###    frame $right.frame1.left -relief raised -bd 1
    frame $right.frame1.left
    frame $right.frame1.right
    set left $right.frame1.left

    #--------------------------------------------------------------
    # Option ClassWidth
    #--------------------------------------------------------------
    set nClassWidth $typeArray(CLASSWIDTH)
    tixControl $left.classWidth -label "Width: " -integer true \
	-variable nClassWidth -min 50 -max 500\
	-command classWidth:Set -step 10 \
	-options { entry.width 12 label.width 16 label.anchor w	}
    #$right.w subwidget entry config -state disabled
    pack $left.classWidth -side top -padx 2 -anchor w

    #--------------------------------------------------------------
    # Option ClassHeight
    #--------------------------------------------------------------
    set nClassHeight $typeArray(CLASSHEIGHT)
    tixControl $left.classHeight -label "Height: " -integer true \
	-variable nClassHeight -min 20 -max 100\
	-command classHeight:Set -step 5\
	-options { entry.width 12 label.width 16 label.anchor w	}
    #$right.h subwidget entry config -state disabled
    pack $left.classHeight -side top -padx 2 -anchor w

    #--------------------------------------------------------------
    # Checkboxen
    #--------------------------------------------------------------
    set right $right.frame1.right

    set classAttributes $typeArray(CLASSATTRIBUTES)
    set classOperations $typeArray(CLASSOPERATIONS)
    set classVisibility $typeArray(CLASSVISIBILITY)
    set classVisiSymbol $typeArray(CLASSVISISYMBOL)
    set classStereotype $typeArray(CLASSSTEREOTYPE)

    checkbutton $right.stereotype -text "Show Stereotype" -anchor nw \
      -command {toggleStereotype} -variable {classStereotype} -selectcolor {gold}
    checkbutton $right.visibility -text "Show Visibility" -anchor nw \
      -command {toggleVisibility} -variable {classVisibility} -selectcolor {gold}
    checkbutton $right.visiSymbol -text "Visibility as Symbol" -anchor nw \
      -command {toggleVisiSymbol} -variable {classVisiSymbol} -selectcolor {gold}
    checkbutton $right.attributes -text "Show Attributes" -anchor nw \
      -command {toggleAttributes} -variable {classAttributes} -selectcolor {gold}
    checkbutton $right.operations -text "Show Operations" -anchor nw \
      -command {toggleOperations} -variable {classOperations} -selectcolor {gold}

    $right.visibility configure -state disabled

    if { $classVisibility == 1  } { 
       $right.visiSymbol configure -state normal
    } else {
       $right.visiSymbol configure -state disabled
    }
  
    #--------------------------------------------------------------
    # wir packen alles zusammen
    #--------------------------------------------------------------
    pack $right.stereotype -side top -anchor nw -expand no -fill x -pady 0
    pack $right.visibility -side top -anchor nw -expand no -fill x -pady 0
    pack $right.visiSymbol -side top -anchor nw -expand no -fill x -pady 0
    pack $right.attributes -side top -anchor nw -expand no -fill x -pady 0
    pack $right.operations -side top -anchor nw -expand no -fill x -pady 0

    set frame1 $w.right.frame1
    pack append $frame1 $frame1.left {left frame nw expand fill}
    pack append $frame1 $frame1.right {left frame nw expand fill}
    pack $frame1 -expand no -fill x -pady 2

}

proc toggleStereotype {} {
}

proc toggleVisibility {} {
    #--------------------------------------------------------------
    # Speichern der Einstellung fuer Visibility
    #--------------------------------------------------------------
    global win_path_for_nstyle
    set w $win_path_for_nstyle

    global typeArray
    global classVisibility
    set typeArray(CLASSVISIBILITY) $classVisibility
    if { $classVisibility == 1  } { 
       $w.right.frame1.right.visiSymbol configure -state normal
    } else {
       $w.right.frame1.right.visiSymbol configure -state disabled
    }
}


proc toggleVisiSymbol {} {
    #--------------------------------------------------------------
    # Speichern der Einstellung fuer Visibility-Symbol
    #--------------------------------------------------------------
    global typeArray
    global classVisiSymbol
    set typeArray(CLASSVISISYMBOL) $classVisiSymbol
}

proc toggleAttributes {} {
    #--------------------------------------------------------------
    # Speichern der Einstellung fuer classAttributes
    #--------------------------------------------------------------
    global typeArray
    global classAttributes
    set typeArray(CLASSATTRIBUTES) $classAttributes
}

proc toggleOperations {} {
    #--------------------------------------------------------------
    # Speichern der Einstellung fuer classOperations
    #--------------------------------------------------------------
    global typeArray
    global classOperations
    set typeArray(CLASSOPERATIONS) $classOperations
}

proc classWidth:Set {sel} {
    #--------------------------------------------------------------
    # Speichern der Einstellung fuer classWidth
    #--------------------------------------------------------------
    global typeArray
    global nClassWidth
    set typeArray(CLASSWIDTH) $nClassWidth
}

proc classHeight:Set {sel} {
    #--------------------------------------------------------------
    # Speichern der Einstellung fuer classHeight
    #--------------------------------------------------------------
    global typeArray
    global nClassHeight
    set typeArray(CLASSHEIGHT) $nClassHeight
}

proc classStrength:Set {sel} {
    #--------------------------------------------------------------
    # Speichern der Einstellung fuer classStrength
    #--------------------------------------------------------------
    global typeArray
    global nClassStrength
    set typeArray(CLASSSTRENGTH) $nClassStrength
}

return ok