# Hier befindet sich nur noch der Aufbau des Toplevel-Fensters fuer die Konfiguration
# Die Prozedur createNoteBook baut die Tabs auf.
# Diese und alle zugehoerigen Prozeduren befinden sich in den Modulen im settings-Verzeichnis
# Die Module beginnen saemtlich mit 'set' und bezeichnen den Unterbereich im Einstellungs-Fenster.
# Attributes, EdgeStyle, Layout, NodeStyle, NodeType, Visibilities, Window, Common

global typeArray
global typeList
global edgeList
global actualType
global h1
global h2
global c1
global c2
global c3
global visi_value
global main_window
global nodeLabel
global edgelabel
global iconposition
global win_path_for_types
global win_path_for_nstyle
global win_path_for_estyle
global win_path_for_layout
global wtextfont
global wtextsize
global sel_just 
global sel_font
global actualType
global selectedType
global allAttr

proc settingsWin {} {
    global typeList
    global main_window
    global allAttr
    global typeArray

#    global actualType
#    global nodeStyle
#    global h1
#    global h2
#    global c1
#    global c2
#    global c3
#    global visi_value
#    global nodeLabel
#    global edgelabel
#    global iconposition
#    global win_path_for_types
#    global win_path_for_tree

    set w .nodeSettings
    if { [winfo exists $w] != 1  } { 

	set typeList [lsort $typeList]

    #--------------------------------------------------------------
    #build list of all attributes:
    #--------------------------------------------------------------
    set allAttr " "
    # da muss ein Space Stehen !!!!
    foreach ent $typeList {
	foreach attr $typeArray($ent,LISTATTR) {
	    set attr [string trimright $attr "|YES"]
	    set attr [string trimright $attr "|NO"]
	    if { [string first " $attr " $allAttr] == -1 && [string first NodeNumber $attr] == -1 } { set allAttr "$allAttr$attr " }
	}
    }
    set allAttr [lsort $allAttr]
    set allAttr "$allAttr None "
    #--------------------------------------------------------------


	set w [toplevel .settings]
	set main_window $w
	wm title $w {General Settings}

	createNoteBook $w
    
	### Common:
	tkwait window $main_window
    } else {
	showMessage "Please close the NodeSettings Window first!"
    }
}

proc nodeStyleWin {} {
    global typeList
    global typeArray
    global main_window
    global win_path_for_nstyle
    global actualType
    global nodeStyle

    set w .settings
    if { [winfo exists $w] != 1  } { 
	set w .nodeStyleWin
	if { [winfo exists $w] == 1  } { destroy $w }
	set typeList [lsort $typeList]

	set w [toplevel .nodeStyleWin]
	set main_window $w
	wm title $w "Style Settings for Nodetype $actualType"

    #--------------------------------------------------------------
    # Rahmen fuer die Widgets
    #--------------------------------------------------------------
	frame $w.top 
	pack $w.top -side top -fill both -expand yes
	set right  $w.top

    #--------------------------------------------------------------
    # Option NodeStyle
    #--------------------------------------------------------------
	tixOptionMenu $right.nodeStyle -label "Style:" \
	    -variable nodeStyle \
	    -command style:set \
	    -options { label.width  14   label.anchor w   menubutton.width 15 }

	set tmp $typeArray($actualType,STYLE)
	$right.nodeStyle add command $tmp -label $tmp
	foreach opt { LABEL BOX RBOX DBOX FBOX CIRCLE DOT PACKAGE CLASS } {
	    if { [string compare $tmp $opt] != 0 } { $right.nodeStyle add command $opt -label $opt }
	}
	pack $right.nodeStyle -side top -anchor w


	#### Use a ButtonBox to hold the buttons ##########################
	create_ButtonBox
    } {
	showMessage "Please close the Settings Window first!"
    }
    
    ### tk Warteschleife
#    tkwait window $main_window
}


proc nodeSettings {} {
    global typeList
    global typeArray
    global main_window
    global win_path_for_nstyle
    global actualType
    global nodeStyle
    global selectedType

    set w .settings
    if { [winfo exists $w] != 1  } { 
	set w .nodeSettings
	if { [winfo exists $w] == 1  } { destroy $w }
	set typeList [lsort $typeList]

	set w [toplevel .nodeSettings]
	set main_window $w
	wm title $w "Settings for Nodetype $actualType"

    #--------------------------------------------------------------
    # Rahmen fuer die Widgets
    #--------------------------------------------------------------
	frame $w.top 
	pack $w.top -side top -fill both -expand yes
	set right  $w.top

    #--------------------------------------------------------------
    # Notebook fuer Knoten aufbauen
    #--------------------------------------------------------------
	createNoteBook_Nodes $right


    #--------------------------------------------------------------
    # Initialwert setzen
    #--------------------------------------------------------------
	set tmp $typeArray($actualType,DISPLAY)
	nodeDisplay:set $tmp

	#### Use a ButtonBox to hold the buttons ##########################
	create_ButtonBox
    } {
	showMessage "Please close the Settings Window first!"
    }
    
}

######################################################################################
##########  PROC DEFS 
######################################################################################

catch { source "$scriptpath/settings/setWindow.tcl" } error_code
on_error_message $error_code setWindow.tcl
catch { source "$scriptpath/settings/setAttributes.tcl" } error_code
on_error_message $error_code setAttributes.tcl
catch { source "$scriptpath/settings/setCommon.tcl" } error_code
on_error_message $error_code setCommon.tcl
catch { source "$scriptpath/settings/setEdgeStyle.tcl" } error_code
on_error_message $error_code setEdgeStyle.tcl
catch { source "$scriptpath/settings/setLayout.tcl" } error_code
on_error_message $error_code setLayout.tcl
catch { source "$scriptpath/settings/setNodeType.tcl" } error_code
on_error_message $error_code setNodeType.tcl
catch { source "$scriptpath/settings/setVisibilities.tcl" } error_code
on_error_message $error_code setVisibilities.tcl
catch { source "$scriptpath/settings/setFontDialog.tcl" } error_code
on_error_message $error_code setFontDialog.tcl
catch { source "$scriptpath/settings/setNode.tcl" } error_code
on_error_message $error_code setNode.tcl
catch { source "$scriptpath/settings/setNodeStyle.tcl" } error_code
on_error_message $error_code setNodeStyle.tcl
catch { source "$scriptpath/settings/setNodeStyleClass.tcl" } error_code
on_error_message $error_code setNodeStyleClass.tcl
catch { source "$scriptpath/settings/setNodeStylePackage.tcl" } error_code
on_error_message $error_code setNodeStylePackage.tcl
catch { source "$scriptpath/settings/setNodeStyleBox.tcl" } error_code
on_error_message $error_code setNodeStyleBox.tcl
catch { source "$scriptpath/settings/setNodeStyleCircle.tcl" } error_code
on_error_message $error_code setNodeStyleCircle.tcl
catch { source "$scriptpath/settings/setNodeStyleDot.tcl" } error_code
on_error_message $error_code setNodeStyleDot.tcl
###catch { source "$scriptpath/settings/setGraph.tcl" } error_code
###on_error_message $error_code setGraph.tcl



return ok
