spec R (* Creates simple resistor networks using a *)
       (* context-free graph grammar. Will be      *)
       (* completed with rules for parsing/analy-  *)
       (* zing (arbitrary) resistor networks.      *)

   node_class B end;

   edge_type w : B -> B;

   node_class R is_a B
      intrinsic
         rv : integer;
   end;

   node_type r : R end;

   node_class C is_a B end;

   node_type c : C end;

   node_class U is_a B
      intrinsic
         uv : integer;
   end;

   node_type u : U end;

   production Create
   =
      (* @CC_LG 7008(8,8)(305,20) @*)
      ::=
      begin
         1' : u;
         (* @CC_LG 6011(50,100)(41,25) @*)
         2' : c;
         (* @CC_LG 6011(130,20)(41,25) @*)
         3' : r;
         (* @CC_LG 6011(210,100)(41,25) @*)
         4' : c;
         (* @CC_LG 6011(130,180)(41,25) @*)
         1' -> 2' : w;
         (* @CC_LG
         3004C3
         50,20 @*)
         2' -> 3' : w;
         (* @CC_LG
         3004C3
         210,20 @*)
         3' -> 4' : w;
         (* @CC_LG
         3004C3
         210,180 @*)
         4' -> 1' : w;
         (* @CC_LG
         3004C3
         50,180 @*)
      end
      (* @CC_LG 7009(8,8)(305,205) @*)
      transfer 1'.uv := 240;
               3'.rv := 360;
   end;

   production Parallel
   =
      begin
         obl_node `1 : r;
         (* @CC_LG 6007(155,24)(51,25) @*)
         opt_set `2 : c;
         (* @CC_LG 6009(39,24)(55,25) @*)
         `2 -> `1 : w;
         (* @CC_LG 0 @*)
         opt_set `3 : c;
         (* @CC_LG 6009(261,24)(55,25) @*)
         `1 -> `3 : w;
         (* @CC_LG 0 @*)
      end
      (* @CC_LG 7008(8,8)(305,53) @*)
      ::=
      begin
         opt_set 2' = `2;
         (* @CC_LG 6009(30,72)(49,25) @*)
         opt_set 3' = `3;
         (* @CC_LG 6009(270,72)(55,25) @*)
         5' : r;
         (* @CC_LG 6011(150,24)(45,25) @*)
         4' : r;
         (* @CC_LG 6011(150,120)() @*)
         7' : c;
         (* @CC_LG 6011(108,72)(45,25) @*)
         6' : c;
         (* @CC_LG 6011(192,72)(45,25) @*)
         2' -> 7' : w;
         (* @CC_LG 0 @*)
         7' -> 5' : w;
         (* @CC_LG 0 @*)
         5' -> 6' : w;
         (* @CC_LG 0 @*)
         6' -> 3' : w;
         (* @CC_LG 0 @*)
         7' -> 4' : w;
         (* @CC_LG 0 @*)
         4' -> 6' : w;
         (* @CC_LG 0 @*)
      end
      (* @CC_LG 7009(8,8)(305,149) @*)
      transfer 4'.rv := 512;
               5'.rv := 512;
   end;

   production Sequence
   =
      begin
         obl_node `1 : r;
         (* @CC_LG 6007(155,24)(51,25) @*)
         opt_set `2 : c;
         (* @CC_LG 6009(39,24)(55,25) @*)
         `2 -> `1 : w;
         (* @CC_LG 0 @*)
         opt_set `3 : c;
         (* @CC_LG 6009(261,24)(55,25) @*)
         `1 -> `3 : w;
         (* @CC_LG 0 @*)
      end
      (* @CC_LG 7008(8,8)(305,53) @*)
      ::=
      begin
         opt_set 2' = `2;
         (* @CC_LG 6009(30,23)(49,25) @*)
         opt_set 3' = `3;
         (* @CC_LG 6009(264,84)(55,25) @*)
         5' : r;
         (* @CC_LG 6011(114,23)(45,25) @*)
         4' : r;
         (* @CC_LG 6011(186,84)(45,25) @*)
         2' -> 5' : w;
         (* @CC_LG 3004 @*)
         4' -> 3' : w;
         (* @CC_LG 3004 @*)
         1' : c;
         (* @CC_LG 6011(114,84)() @*)
         5' -> 1' : w;
         (* @CC_LG 0 @*)
         1' -> 4' : w;
         (* @CC_LG 0 @*)
      end
      (* @CC_LG 7009(8,8)(305,113) @*)
      transfer 4'.rv := 128;
               5'.rv := 128;
   end;

   transaction Grammar_MAIN
   =
        Create
      & loop
              Parallel
           or Sequence
        end
   end;

   transaction MAIN
   =
        Create
      & Parallel
      & Sequence
   end;

end.
