/****************/
/* ExecSystem.h */
/****************/

/************************************************/
/* header file for imported types and functions */
/************************************************/


#include "C_PGC.h"



/****************************************/
/* type definition of the imported type */
/****************************************/


/******************************************************/
/* interface of standard functions for imported types */
/******************************************************/

/* The following three procedures are obligatory in connection
 * with an imported type. They must not be used in the specification
 * explicitely, but they are needed for internal use (e.g. conversion
 * from text to string and vice versa. */
/* Note: The procedure names and the parameters (type and order) are important.
 * The convention is, that in procedures results are returned as the first  
 * parameter. */

/*
void CVSstate_Size (int *);

void CVSstate_ValueToString (PGCMString *, CVSstate *);

void CVSstate_StringToValue (CVSstate *, PGCMString *);
*/

/************************************************/
/* interface of user-defined imported functions */
/************************************************/

/* ------------------------------------------------------------------- *
 *  CheckOut an revision, if not already done                          *
 * ------------------------------------------------------------------- */

void CheckOut (BOOLEAN* retval, PGCMString* pfilename, PGCMString* prevision);

/* ------------------------------------------------------------------- *
 *  retrieve the revision number from file (using cvs status)          *
 * ------------------------------------------------------------------- */

getRevision(PGCMString* prevision, PGCMString* pfilename);

/* ------------------------------------------------------------------- *
 *  commit a revision                                                  *
 * ------------------------------------------------------------------- */

commitRevision(PGCMString* prevision, PGCMString* pfilename);

/* ------------------------------------------------------------------- *
 *  set the root directory                                             *
 * ------------------------------------------------------------------- */

setBaseDir(BOOLEAN* retval, PGCMString* pbasedir);
