/***************/
/* ExecSystem.c */
/***************/

/**************************************************/
/* implementation of imported types and functions */
/**************************************************/

/***************************************************************************/
/*                                                                         */
/*  ATTENTION: please SET environment Variable "IMPORTLIB" according       */
/*             to the library containing the object code of the            */
/*             imported types and functions.                               */
/*                                                                         */
/***************************************************************************/

/* Note further that an imported type needs to be provided with at 
   least three pre-defined functions that are needed for PROGRES built-in 
   functionality.
   * (let USERTYPE be the type to be imported)
   *  - USERTYPE_Size returns the size of the type in the parameter
   *  - USERTYPE_ValueToString writes the contents of the imported type to a string, 
   *    that will be returned in the first parameter
   *  - USERTYPE_StringToValue converts a string to USERTYPE and returns it by
   *    parameter
   * Remark: The formerly needed procedures WriteConst and ReadConst are obsolete!

   * Further user-defined functions for an imported type have the following rules: 
   * Assume that you want to import a function in the specification:
   *   MyImportedFunction : (T1, ..., Tn) -> Tr
   * where types T1, ..., Tn, Tr are imported or built-in types.
   * The procedure implementing the function above must then look like:
   *   PROCEDURE MyImportedFunction (Tr *pr, T1 *p1, ..., Tn *pn);
   * p1, ..., pn are the in-paramters and pr is the result of the function.
   *
   * Note: All parameters must be passed by address (for technical reasons)
 */


#include <stdio.h>
#include <stdlib.h>

/* use type definition of text in the header file */
#include "ExecSystem.h"


/* header of local functions */


/*****************************************************/
/* implementation of user-defined imported functions */
/*****************************************************/

void ExecSystemCall (int* retval, PGCMString* pgcmstr)

{
	char*	exec;
	char*	s;
	char*	command;
	int		i,j, ci, replace;
	
	s = pgcmstr->s;
	exec = getenv("EXEC_COMMAND_PATH");

	/* how many replacements */
	replace = 0;
	for (i=0; s[i]!=0; i++) if (s[i] == '$') replace++;

	if ((exec != NULL) && (replace>0)) {
		command = malloc(strlen(s) + replace * strlen(exec) + 1);
		ci = 0;
		for (i=0; s[i]!=0; i++) {
			if (s[i] == '$') {
				for (j=0; exec[j]!=0; j++)
					command[ci++] = exec[j];
			}
			else
				command[ci++] = s[i];
		}
		command[ci++] = 0;
	}
	else
		command = s;
	*retval = system(command);
}
