/* Headerdatei fuer GenericSets. */
/* Automatisch generiert */
/* Typedeklarationen stehen in C_Global.h in Abschnitt GenericSets */
#include <m3_aox.h>

#if !defined (C_GenericSets_h_)
#define C_GenericSets_h_

#ifdef __cplusplus
extern "C" {
#endif

#include <ansi.h>
#include <string.h>
#include <stdio.h>
#include <rgglobal.h>
#include <CTypesForM3.h>
#include <C_Local.h>

/**************************************************************************
 *                                                                        *
 *  PROGRES environment: an integrated set of tools for PROgramming       *
 *                       with Graph REwriting Systems.                    *
 *                                                                        *
 *  Copyright (C) 1987-1992  Lehrstuhl Informatik III, RWTH Aachen        *
 *                                                                        *
 *  This library is free software; you can redistribute it and/or         *
 *  modify it under the terms of the GNU Library General Public           *
 *  License as published by the Free Software Foundation; either          *
 *  version 2 of the License, or (at your option) any later version.      *
 *                                                                        *
 *  This library is distributed in the hope that it will be useful,       *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU     *
 *  Library General Public License for more details.                      *
 *                                                                        *
 *  You should have received a copy of the GNU Library General Public     *
 *  License along with this library; if not, write to the Free            *
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.    *
 *                                                                        *
 *  Contact Adresses:                                                     *
 *                                                                        *
 *      Dr. Andy Sch"urr (or Cornelia Weigmann),                          *
 *      Lehrstuhl f"ur Informatik III,                                    *
 *      University of Technology Aachen (RWTH Aachen),                    *
 *      Ahornstr. 55,                                                     *
 *      D-5100 Aachen                                                     *
 *                                                                        *
 *  Email to                                                              *
 *                                                                        *
 *      andy@rwthi3.informatik.rwth-aachen.de                             *
 *      cornelia@rwthi3.informatik.rwth-aachen.de (for technical support) *
 *                                                                        *
 **************************************************************************/
/**************************************************************************
 * Datentypmodul fuer generische Mengen.                                  *
 *                                                                        *
 * $Author: prom3 $
   $Revision: 1.1.1.1 $
   $Date: 1997/05/30 15:53:31 $
   $State: Exp $
   $Log: GenericSets.i3,v $
   Revision 1.1.1.1  1997/05/30 15:53:31  prom3
   prom3 unter CVS-Kontrolle... (mm)

   Revision 1.10  1997/04/17 15:25:19  roetschk
   Speichereffizienz von GenericSets fuer Strings und importierte Typen
   verbessert. PGCode fuer Vergleich von importierten Typen eingefuegt.

   Revision 1.9  1996/01/22 21:18:10  muench
   Umbauten der GenericSets:
   Der Parameter CmpProc bei SetCreate ist weggefallen. Es wird nicht mehr
   explizit eine Compare-Prozedur uebergeben, sondern es wird intern
   unterschieden, welche Vergleichsprozedur benutzt wird. Es gibt naemlich
   bislang nur zwei Prozeduren: Eine fuer Strings und eine fuer alles ausser
   Strings. Frueher wurde vor einem SetCreate ein Hack eingebaut, der heraus-
   finden sollte, welche Prozedur Verwendung finden sollte. Heute ist dieser
   Hack in die GenericSets gerutscht. Dort wird anhand der Groesse der Elemente
   unterschieden, ob es sich um Strings handelt, oder nicht. Entsprechend
   wird CmpProc auf StringCompareProc oder OtherCompareProc gesetzt (neue
   CompareProcTypes!). Diese Methode laesst sich natuerlich spaeter beliebig
   um andere Typen erweitern, falls weitere benutzerdefinierte Vergleichs-
   prozeduren hinzukommen sollten. Im Zuge dieser Umbauten sind auch
   SetCreateStandard und SetCreateStandardForN weggefallen, die nun durch
   SetCreate bzw. SetCreateForN ersetzt werden. (mm)

   Revision 1.8  1995/12/05 16:24:30  ortmann
   In PGCExecutionBasics hat die Prozedur 'Substr' jetzt als Eingabeparameter
   die linke Grenze und dann die rechte Grenze und zwar genau in dieser
   Reihenfolge !!

# Revision 1.7  1994/08/04  11:14:29  pgcm
# C-Warnings corrected
#
# Revision 1.6  1994/08/02  17:06:28  pgcm
# Vervollstaedigung C-Schnittstelle
#
# Revision 1.5  1994/04/13  11:58:36  uli
# Auf die Verantwortung von Albert, die Anpassungen fuer EPC
# eingecheckt.
# Diverse ARRAY SHORTCARD so verkleinert, dass der Stack nicht platzt.
#
# Revision 1.4  1993/12/30  17:07:28  gva
# Neue Prozedur SetExtractRndElement in genericSets eingebaut.
# Das AND und das OR arbeiten jetzt "nichtdeterministisch".
#
# Revision 1.3  1993/03/31  14:58:09  gva
# Kosmetik
#
# Revision 1.2  1993/03/29  20:23:13  albert
# Kleine Erweiterungen. Albert
#
# Revision 1.1  1993/03/23  20:26:30  guido
# In diesem Verzeichnis sind die zur Ausfuehrung des generierten M2-Codes
# notwendigen Module enthalten.
# Sie wurden aus der ProgGraphCodeMachineLib noch hier verlegt.
#
# Revision 3.4  1993/03/17  20:45:04  andre
# Fehler behoben.
#
# Revision 3.3  1993/03/05  13:19:57  guido
# Verbesserte Behandlung der generischen Mengen.
# Hierzu in GenericSets neue Prozeduren: SetCreateStandard, SetCreateStandardForN
# PGCExecutionBasics.mod angepasst.
#
# Revision 3.2  1992/12/22  10:53:03  pro92
# Copyright eingetragen
#
# Revision 3.1  1991/11/10  17:04:20  pk
# Mengenwertige Operanden eingefuehrt.
#
*
 **************************************************************************/

 
 
 
 
 /************************************************************************
 *                                                                      *
 *                     Organisatorische Operationen                     *
 *                                                                      *
 ************************************************************************/

void
SetCreate(Set_Type *Set, CARDINAL DataBytes);
/**********************************************************************
 * Erzeugen einer neuen Menge. Die Anwendung muss fuer eine neue      *
 * Klasse eine Ordnung definieren, um die effiziente Verwaltung der   *
 * Menge zu gewaehrleisten. Die definierte Ordnung muss der Defi-     *
 * nition einer Ordnungsrelation genuegen. Weiter muss angegeben wer- *
 * den, welche Laenge (in BYTEs) die zu speichernden Elemente haben.  *
 * Dazu kann die SYSTEM-Funktion TSIZE (oder SIZE) benutzt werden.    *
 * SetCreate muss aufgerufen werden, bevor eine Operation mit der     *
 * Menge moeglich ist. Nach dem Erzeugen ist die Menge leer. Bereits  *
 * definierte Mengen sollten mit SetKill geloescht werden.            *
 **********************************************************************/

void
SetSetUndefined(Set_Type *Set);

 
 
 
 
 
 
 
 
 
 
 
 /**********************************************************************
 * Setzen des Parameters Set auf Undefiniert. Dabei wird nicht ge-    *
 * loescht! Eine bereits erzeugte Menge sollte vorher mit SetKill     *
 * freigegeben werden.                                                *
 **********************************************************************/

BOOLEAN
SetIsDefined(Set_Type Set);
/**********************************************************************
 * Test, ob eine Menge mit SetCreate erzeugt wurde. Diese Funktion    *
 * beitet nur dann korrekt, wenn Zeiger vom Compiler mit NIL vorbe-   *
 * setzt werden oder vorher SetSetUndefined aufgerufen wird.          *
 **********************************************************************/

void
SetKill(Set_Type *Set);
/**********************************************************************
 * Loeschen einer vorher erzeugten Menge mit Freigabe des von ihr     *
 * belegten Speicherplatzes. Fuer weitere Operationen mit dieser      *
 * Menge muss erneut SetCreate aufgerufen werden!                     *
 **********************************************************************/
/************************************************************************
 *                                                                      *
 *                        Informationsprozeduren                        *
 *                                                                      *
 ************************************************************************/

CARDINAL
GetCard(Set_Type Set);
/**********************************************************************
 * Ermitteln der Kardinalitaet einer (erzeugten) Menge.               *
 **********************************************************************/

BOOLEAN
IsSetEmpty(Set_Type Set);
/**********************************************************************
 * Test, ob eine (vorher definierte) Menge leer ist.                  *
 **********************************************************************/

CARDINAL
GetElementSize(Set_Type Set);
/**********************************************************************
 * Ermittle die Groesse eines Elements der Menge Set.                 *
 **********************************************************************/

SetCompareProcType
GetCompareProc(Set_Type Set);
/**********************************************************************
 * Ermittle die fuer Set angemeldete Vergleichsprozedur.              *
 **********************************************************************/
/************************************************************************
 *                                                                      *
 *                          Loeschoperationen                           *
 *                                                                      *
 ************************************************************************/

void
SetRemoveElement(Set_Type *Set, BYTE_ARRAY DataPar, CARDINAL HighDataPar);
/**********************************************************************
 * Loeschen eines Datums aus einer vorher erzeugten Menge. Wenn das   *
 * Datum nicht in der Menge ist, passiert nichts.                     *
 * VORSICHT: Es findet keine Typueberpruefung statt. Die Anwendung    *
 * muss also selbst dafuer sorgen, dass das Datum zur Mengenklasse    *
 * gehoert! Wenn die uebergebene Variable nicht lang genug fuer das   *
 * Mengenelement ist, erfolgt ein Fehlerabbruch!                      *
 **********************************************************************/

void
SetDeleteElement(Set_Type *Set, BYTE_ARRAY DataPar, CARDINAL HighDataPar, BOOLEAN *Found);
/**********************************************************************
 * Loeschen eines Datums aus einer vorher erzeugten Menge. Found gibt *
 * an, ob das Element in der Menge war.                               *
 * VORSICHT: Es findet keine Typueberpruefung statt. Die Anwendung    *
 * muss also selbst dafuer sorgen, dass das Datum zur Mengenklasse    *
 * gehoert! Wenn die uebergebene Variable nicht lang genug fuer das   *
 * Mengenelement ist, erfolgt ein Fehlerabbruch!                      *
 **********************************************************************/
/************************************************************************
 *                                                                      *
 *                Einfuege- und Veraenderungsoperationen                *
 *                                                                      *
 ************************************************************************/

void
SetInsert(Set_Type *Set, BYTE_ARRAY DataPar, CARDINAL HighDataPar);
/**********************************************************************
 * Einfuegen eines Datums in eine Menge. Die Menge muss vorher er-    *
 * zeugt worden sein.                                                 *
 * BEMERKUNG: Wenn bereits ein Element X in der Menge existiert, fuer *
 * das gilt: Cmp(Data,X)=SetEqual, so wird Data nicht in die Menge    *
 * eingefuegt. Insbesondere wird der Inhalt von Data nicht auf X      *
 * kopiert. Diese Funktionalitaet wird durch SetReplaceValue gewaehr- *
 * leistet.                                                           *
 * BEMERKUNG 2: Man sollte es wenn moeglich vermeiden, Elemente sor-  *
 * tiert in eine Menge einzufuegen (etwa bei der Initialisierung),    *
 * denn das hat ein optimal unguenstiges internes Mengenlayout zur    *
 * Folge. Man sollte stattdessen untersuchen, ob SetCreate/InsertUptoN*
 * benutzt werden kann.                                               *
 * VORSICHT: Es findet keine Typueberpruefung statt. Die Anwendung    *
 * muss also selbst dafuer sorgen, dass das Datum zur Mengenklasse    *
 * gehoert! Wenn die uebergebene Variable nicht lang genug fuer das   *
 * Mengenelement ist, erfolgt ein Fehlerabbruch!                      *
 **********************************************************************/
/************************************************************************
 *                                                                      *
 *                        Anfrageoperationen                            *
 *                                                                      *
 ************************************************************************/

void
SetExtractAnyElement(Set_Type *Set, BYTE_ARRAY DataPar, CARDINAL HighDataPar, BOOLEAN *Found);
/**********************************************************************
 * Rueckgabe eines beliebigen Elementes einer (vorher definierten)    *
 * Menge. Die Reihenfolge, in der die Elemente zurueckgegeben werden, *
 * ist beliebig. Das Element wird gleichzeitig aus der Menge ent-     *
 * fernt.                                                             *
 * VORSICHT: Es findet keine Typueberpruefung statt. Die Anwendung    *
 * muss also selbst dafuer sorgen, dass das Datum zur Mengenklasse    *
 * gehoert! Wenn die uebergebene Variable nicht lang genug fuer das   *
 * Mengenelement ist, erfolgt ein Fehlerabbruch!                      *
 **********************************************************************/

void
SetExtractRndElement(Set_Type *Set, BYTE_ARRAY DataPar, CARDINAL HighDataPar, BOOLEAN *Found);
/**********************************************************************
 * Rueckgabe eines beliebigen Elementes einer (vorher definierten)    *
 * Menge. Die Reihenfolge, in der die Elemente zurueckgegeben werden, *
 * ist wirklich zufaellig (interner Zufallszahlengenerator). Das Ele- *
 * ment wird gleichzeitig aus der Menge entfernt. Ist man an einer    *
 * wirklich zufaelligen Reihenfolge gar nicht interessiert, so sollte *
 * man aus Effizienzgesichtspunkten lieber die Prozedur SETExtractAny-*
 * Element benutzen.                                                  *
 * VORSICHT: Es findet keine Typueberpruefung statt. Die Anwendung    *
 * muss also selbst dafuer sorgen, dass das Datum zur Mengenklasse    *
 * gehoert! Wenn die uebergebene Variable nicht lang genug fuer das   *
 * Mengenelement ist, erfolgt ein Fehlerabbruch!                      *
 * BEMERKUNG: Ein Aufruf der Prozedur SETExtractAnyElement darf nicht *
 * in einer SETRangeLoop/SETGet-Schleife stehen.                      *
 * BEISPIEL:                                                          *
 *   vorher           nach ExtractAnyElement                          *
 *   {A,C,D}          {A,C} oder {A,D} oder {C,D}                     *
 **********************************************************************/
/************************************************************************
 *                                                                      *
 *                    Mathematische Mengenoperationen                   *
 *                                                                      *
 ************************************************************************/

BOOLEAN
IsElementOf(Set_Type Set, BYTE_ARRAY DataPar, CARDINAL HighDataPar);
/**********************************************************************
 * Test, ob ein Element in einer (erzeugten) Menge ist.               *
 * VORSICHT: Es findet keine Typueberpruefung statt. Die Anwendung    *
 * muss also selbst dafuer sorgen, dass das Datum zur Mengenklasse    *
 * gehoert! Wenn die uebergebene Variable nicht lang genug fuer das   *
 * Mengenelement ist, erfolgt ein Fehlerabbruch!                      *
 **********************************************************************/

void
SetUnion(Set_Type *FirstSet, Set_Type SecondSet);
/**********************************************************************
 * Berechnung der Vereinigung zweier Mengen der gleichen Klasse. Die  *
 * Mengen muessen vorher erzeugt worden sein. Das Ergebnis wird auf   *
 * FirstSet ueberspeichert. SecondSet bleibt unveraendert.            *
 **********************************************************************/

void
SetIntersection(Set_Type *FirstSet, Set_Type SecondSet);
/**********************************************************************
 * Berechnung des Durchschnitts zweier Mengen der gleichen Klasse.    *
 * Die Mengen muessen vorher erzeugt worden sein. Das Ergebnis wird   *
 * auf FirstSet ueberspeichert. SecondSet bleibt unveraendert.        *
 **********************************************************************/

void
SetDifference(Set_Type *FirstSet, Set_Type SecondSet);
/**********************************************************************
 * Berechnung der Differenz FirstSet-SecondSet zweier Mengen der      *
 * chen Klasse. Die Mengen muessen vorher erzeugt worden sein. Das    *
 * Ergebnis wird auf FirstSet ueberspeichert. SecondSet bleibt unver- *
 * aendert.                                                           *
 **********************************************************************/
/************************************************************************
 *                                                                      *
 *                         Sonstige Prozeduren                          *
 *                                                                      *
 ************************************************************************/

void
SetCompact(Set_Type *Set);
/**********************************************************************
 * Kompaktifizieren einer Menge. Diese Operation sollte ab und zu     *
 * aufgerufen werden, wenn in einer Menge viel geloescht und wieder   *
 * eingefuegt wird, denn geloeschte Elemente werden nicht physisch    *
 * geloescht, sondern nur als geloescht gekennzeichnet. Zusaetzlich   *
 * erzeugt SetCompact eine moeglichst effiziente Darstellung der      *
 * Menge. Die Menge muss vorher erzeugt worden sein.                  *
 **********************************************************************/

void
SetCopy(Set_Type Source, Set_Type *Target);
/**********************************************************************
 * Kopieren einer Menge Source auf eine Menge Target. Die Zielmenge   *
 * wird intern erzeugt und sollte vorher eventuell mit SetKill frei-  *
 * gegeben werden, wenn sie bereits definiert war.                    *
 **********************************************************************/

void
SetLoop(Set_Type *Set);
/**********************************************************************
 * Start einer Schleife ueber eine (definierte) Menge.                *
 **********************************************************************/

void
SetGet(Set_Type *Set, BYTE_ARRAY DataPar, CARDINAL HighDataPar, BOOLEAN *Found);
/**********************************************************************
 * Holen eines Elementes aus einer (definierten) Menge, fuer die zu-  *
 * vor mit SetLoop oder SetRangeLoop eine Schleife begonnen wurde.    *
 * SetGet liefert die Elemente in der Reihenfolge ihrer Sortierung,   *
 * beginnend mit dem kleinsten Element, zurueck.                      *
 * VORSICHT: Es findet keine Typueberpruefung statt. Die Anwendung    *
 * muss also selbst dafuer sorgen, dass das Datum zur Mengenklasse    *
 * gehoert! Wenn die uebergebene Variable nicht lang genug fuer das   *
 * Mengenelement ist, erfolgt ein Fehlerabbruch!                      *
 **********************************************************************/
/************************************************************************
 *                                                                      *
 *  	     Spezielle Operationen                                 *
 *                                                                      *
 ************************************************************************/

void
SetCreateForN(Set_Type *Set, CARDINAL DataBytes, CARDINAL N);
/**********************************************************************
 * Erzeugen einer Menge, von der vorher bekannt ist, wieviele Elemen- *
 * te zunaechst einmal eingefuegt werden sollen und bei der ein sor-  *
 * tiertes Einfuegen der Elemente moeglich ist. Diese Prozedur wird   *
 * angeboten, um eine moeglichst effiziente interne Darstellung einer *
 * Menge erzeugen zu koennen. Sie kann allerdings nur unter den zu-   *
 * vor genannten Bedingungen benutzt werden. Dabei heisst "sortiertes *
 * Einfuegen" der Mengenelemente, dass sie gemaess der fuer die Men-  *
 * genklasse definierten Ordnung sortiert sind.                       *
 * WICHTIG: Zum Einfuegen von Elementen in eine Menge, die mit        *
 * SetCreateForN erzeugt wurde, ist die Prozedur SetInsertUptoN zu    *
 * benutzen, keinesfalls SetInsert!                                   *
 * Es duerfen keine Mengenveraendernden Operationen auf Set angewandt *
 * werden, bevor alle N Elemente eingefuegt sind!                     *
 **********************************************************************/

 
 /**********************************************************************
 * Wie SetCreateForN, hier wird aber eine Standard-Vergleichsprozedur *
 * verwendet. (Siehe SetCreateStandard).                              *
 **********************************************************************/

void
SetInsertUptoN(Set_Type *Set, BYTE_ARRAY DataPar, CARDINAL HighDataPar);
/**********************************************************************
 * Einfuegen von N Elementen in eine mit SetCreateForN erzeugte Menge.*
 * Dabei muessen die Elemente gemaess der Ordnung, die fuer die Men-  *
 * genklasse definiert ist, eingegeben werden. SetInsertUptoN muss    *
 * genau so oft aufgerufen werden, bis die Zahl erreicht ist, die bei *
 * SetCreateForN angegeben wurde.                                     *
 * VORSICHT: Es findet keine Typueberpruefung statt. Die Anwendung    *
 * muss also selbst dafuer sorgen, dass das Datum zur Mengenklasse    *
 * gehoert! Wenn die uebergebene Variable nicht lang genug fuer das   *
 * Mengenelement ist, erfolgt ein Fehlerabbruch!                      *
 **********************************************************************/
#ifdef __cplusplus
}
#endif

#endif /* C_GenericSets_h_ */
