/* Headerdatei fuer StandardTypes. */
/* Automatisch generiert */
/* Typedeklarationen stehen in C_Global.h in Abschnitt StandardTypes */
#include <m3_aox.h>

#if !defined (C_StandardTypes_h_)
#define C_StandardTypes_h_

#ifdef __cplusplus
extern "C" {
#endif

#include <ansi.h>
#include <string.h>
#include <stdio.h>
#include <rgglobal.h>
#include <CTypesForM3.h>
#include <C_Local.h>

/**************************************************************************
 *                                                                        *
 *  PROGRES environment: an integrated set of tools for PROgramming       *
 *                       with Graph REwriting Systems.                    *
 *                                                                        *
 *  Copyright (C) 1987-1992  Lehrstuhl Informatik III, RWTH Aachen        *
 *                                                                        *
 *  This library is free software; you can redistribute it and/or         *
 *  modify it under the terms of the GNU Library General Public           *
 *  License as published by the Free Software Foundation; either          *
 *  version 2 of the License, or (at your option) any later version.      *
 *                                                                        *
 *  This library is distributed in the hope that it will be useful,       *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU     *
 *  Library General Public License for more details.                      *
 *                                                                        *
 *  You should have received a copy of the GNU Library General Public     *
 *  License along with this library; if not, write to the Free            *
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.    *
 *                                                                        *
 *  Contact Adresses:                                                     *
 *                                                                        *
 *      Dr. Andy Sch"urr (or Cornelia Weigmann),                          *
 *      Lehrstuhl f"ur Informatik III,                                    *
 *      University of Technology Aachen (RWTH Aachen),                    *
 *      Ahornstr. 55,                                                     *
 *      D-5100 Aachen                                                     *
 *                                                                        *
 *  Email to                                                              *
 *                                                                        *
 *      andy@rwthi3.informatik.rwth-aachen.de                             *
 *      cornelia@rwthi3.informatik.rwth-aachen.de (for technical support) *
 *                                                                        *
 **************************************************************************/

void
StandardTypeToASCII(StandardType Type, CHAR_ARRAY s);

void
StandardTypeToText(StandardType Type, CHAR_ARRAY s);

CARDINAL
GetStandardTypeSize(StandardType Type);

void
WriteStringToValue(BYTE_ARRAY DataPtr, CARDINAL HighDataPtr, StandardType StType, CHAR_ARRAY s, GraphNumber Graph, BOOLEAN *Success);

void
WriteValueToString(CHAR_ARRAY s, SHORTCARD *l, GraphNumber Graph, StandardType StType, ADDRESS DataPtr);

void
Write_BOOLEAN(CHAR_ARRAY s, SHORTCARD *l, BOOLEANPtr Value);

void
Write_INTEGER(CHAR_ARRAY s, SHORTCARD *l, INTEGERPtr Value);

void
Write_REAL(CHAR_ARRAY s, SHORTCARD *l, REALPtr Value);

void
Write_SHORTCARD(CHAR_ARRAY s, SHORTCARD *l, SHORTCARDPtr Value);

void
Write_String(CHAR_ARRAY s, SHORTCARD *l, STRINGPtr Value);

void
WriteAGGlobal_Graphnumber(CHAR_ARRAY s, SHORTCARD *l, GraphNumberPtr Value);

void
WriteAGGlobal_Nodenumber(CHAR_ARRAY s, SHORTCARD *l, NodeNumberPtr Value);

void
WriteAGGlobal_Surrogate(CHAR_ARRAY s, SHORTCARD *l, SurrogatePtr Value);

void
WriteAGGlobal_Attributetype(CHAR_ARRAY s, SHORTCARD *l, AttributeKindPtr Value);

void
WriteAGGlobal_ExternNumber(CHAR_ARRAY s, SHORTCARD *l, ExternNumberPtr Value);

void
WriteAGGlobal_TStatus(CHAR_ARRAY s, SHORTCARD *l, TStatusPtr Value);

void
WriteAGGlobal_GraphType(CHAR_ARRAY s, SHORTCARD *l, GraphTypePtr Value);

void
WriteAGGlobal_AttNumberType(CHAR_ARRAY s, SHORTCARD *l, AttributeNumberPtr Value);

void
WriteAGGlobal_Edgelabel(CHAR_ARRAY s, SHORTCARD *l, TypeNumberPtr Value);

void
WriteAGGlobal_Cardinality(CHAR_ARRAY s, SHORTCARD *l, CardinalityPtr Value);

void
WriteAGGlobal_IndexProperties(CHAR_ARRAY s, SHORTCARD *l, IndexPropertiesPtr Value);

void
WritePGCGlobal_SetDescription(CHAR_ARRAY s, SHORTCARD *l, SetDescriptionPtr Value);

void
WritePGCGlobal_AbsAddressType(CHAR_ARRAY s, SHORTCARD *l, AbsAddressTypePtr Value);

void
WritePGCGlobal_ArithmeticOperators(CHAR_ARRAY s, SHORTCARD *l, ArithmeticOperatorsPtr Value);

void
WritePGCGlobal_SchemeComponentNumber(CHAR_ARRAY s, SHORTCARD *l, GraphNumber Graph, SchemeComponentNumberPtr Value);

void
WritePGCGlobal_ControlFlowEdgeType(CHAR_ARRAY s, SHORTCARD *l, ControlFlowEdgeTypePtr Value);

void
WriteBacktrackTypes_BacktrackInfo(CHAR_ARRAY s, SHORTCARD *l, BacktrackInfoPtr Value);

void
ConvertSingleStringToValue(CHAR_ARRAY s, StandardType StType, GraphNumber Graph, BYTE_ARRAY Val, CARDINAL HighVal, BOOLEAN *Success);

CARDINAL
AdjustElemSize(CARDINAL TypeSize, ADDRESS *InElemPtr, BOOLEAN ChangeOk, BOOLEAN *IsDifferent);

void
CheckReturnedLength(CARDINAL RetLength, CARDINAL ElemSize, BOOLEAN *Success);

BOOLEAN
IsStringSize(CARDINAL ElemSize);

BOOLEAN
IsImportedDataSize(CARDINAL ElemSize);

CARDINAL
GetImportedDataLen(ADDRESS Buffer);

void
SetImportedDataLen(ADDRESS Buffer, CARDINAL Len);
#ifdef __cplusplus
}
#endif

#endif /* C_StandardTypes_h_ */
