/*********************************************************************/
/*                                                                   */
/* Copyright 1994/95/96 Carsten Friedrich, University of Passau.     */
/*                                                                   */
/* For details see the copyright file included in the distribution.  */
/* This notice must not be removed from the file.                    */
/*                                                                   */
/*********************************************************************/
// This may look like C code, but it is really -*- C++ -*-
/* 
Copyright (C) 1988 Free Software Foundation
    written by Doug Lea (dl@rocky.oswego.edu)

This file is part of the GNU C++ Library.  This library is free
software; you can redistribute it and/or modify it under the terms of
the GNU Library General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.  This library is distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU Library General Public License for more details.
You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free Software
Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/


#ifndef _SLStack_h
#ifdef __GNUG__
#pragma interface
#endif
#define _SLStack_h 1

#include "SLList.h"
#include "MFStack.h"

template<class Type>
class SLStack : public MFStack<Type>
{
  SLList<Type>     p;

public:
 SLStack();
 SLStack(const SLStack& s);
 ~SLStack();
 
 void          operator = (const SLStack&);
 
 void          push(Type  item);
 Type           pop();
 Type&          top();               
 void          del_top();
 
 int           empty();
 int           full();
 int           length();
 
 void          clear();
 
 int           OK();
 
};

template<class Type>
inline SLStack<Type>::SLStack() :p() {}

template<class Type>
inline SLStack<Type>::SLStack(const SLStack& a) : p(a.p) {}

template<class Type>
inline SLStack<Type>::~SLStack() {}

template<class Type>
inline void SLStack<Type>::push(Type  item)
{
  p.prepend(item);
}

template<class Type>
inline Type SLStack<Type>::pop()
{
  return p.remove_front();
}

template<class Type>
inline Type& SLStack<Type>::top()
{
  return p.front();
}

template<class Type>
inline void SLStack<Type>::del_top()
{
  p.del_front();
}

template<class Type>
inline void SLStack<Type>::operator =(const SLStack& s)
{
  p = s.p;
}

template<class Type>
inline int SLStack<Type>::empty() 
{
  return p.empty();
}

template<class Type>
inline int SLStack<Type>::full() 
{
  return 0;
}

template<class Type>
inline int SLStack<Type>::length() 
{
  return p.length();
}

template<class Type>
inline int SLStack<Type>::OK() 
{
  return p.OK();
}

template<class Type>
inline void SLStack<Type>::clear() 
{
  p.clear();
}

#endif
