/*********************************************************************/
/*                                                                   */
/* Copyright 1994/95/96 Carsten Friedrich, University of Passau.     */
/*                                                                   */
/* For details see the copyright file included in the distribution.  */
/* This notice must not be removed from the file.                    */
/*                                                                   */
/*********************************************************************/
// This may look like C code, but it is really -*- C++ -*-
/* 
Copyright (C) 1988 Free Software Foundation
    written by Doug Lea (dl@rocky.oswego.edu)

This file is part of the GNU C++ Library.  This library is free
software; you can redistribute it and/or modify it under the terms of
the GNU Library General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.  This library is distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU Library General Public License for more details.
You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free Software
Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/


#ifndef _VHBag_h
#ifdef __GNUG__
#pragma interface
#endif
#define _VHBag_h 1

// #include "globdefs.h"
#ifndef DEFAULT_INITIAL_CAPACITY
/* Allgemeiner Wert von 5000 ist zu hoch, zureckgesetzt auf 100 (Dirk) */
#define DEFAULT_INITIAL_CAPACITY 5
#endif

#include "MFBag.h"

template<class Type>
class VHBag : public MFBag<Type>
{
protected:
 Type*          tab;
 char*         status;
 unsigned int  size;
 
public:
 VHBag(unsigned int sz = DEFAULT_INITIAL_CAPACITY);
 VHBag(VHBag& a);
 ~VHBag();

  Pix add(Type  item);
  void del(Type  item);
  void remove(Type item);
  int nof(Type  item);
  int contains(Type  item);

  void clear();

  Pix first();
  void next(Pix& i);
  Type& operator () (Pix i);
  Pix seek(Type  item, Pix from = 0);

  int capacity();
  void resize(unsigned int newsize = 0);

  int OK();
};

template<class Type>
inline VHBag<Type>::~VHBag()
{
  delete [] tab;
  delete status;
}


template<class Type>
inline int VHBag<Type>::capacity()
{
  return size;
}

template<class Type>
inline int VHBag<Type>::contains(Type  key)
{
  return seek(key) != 0;
}

template<class Type>
inline Type& VHBag<Type>::operator () (Pix i)
{
  if (i == 0) error("null Pix");
  return *((Type*)i);
}

#endif
