/*********************************************************************/
/*                                                                   */
/* Copyright 1994/95/96 Carsten Friedrich, University of Passau.     */
/*                                                                   */
/* For details see the copyright file included in the distribution.  */
/* This notice must not be removed from the file.                    */
/*                                                                   */
/*********************************************************************/
// This may look like C code, but it is really -*- C++ -*-
/* 
Copyright (C) 1988 Free Software Foundation
    written by Doug Lea (dl@rocky.oswego.edu)

This file is part of the GNU C++ Library.  This library is free
software; you can redistribute it and/or modify it under the terms of
the GNU Library General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.  This library is distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU Library General Public License for more details.
You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free Software
Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef _VHMap_h
#ifdef __GNUG__
#pragma interface
#endif
#define _VHMap_h 1

#include "MFMap.h"

#ifndef DEFAULT_INITIAL_CAPACITY
#define DEFAULT_INITIAL_CAPACITY 5
#endif

template<class Type1, class Type2>
class VHMap : public MFMap<Type1,Type2>
{
protected:
  Type1*           tab;
  Type2*           cont;
  char*          status;
  unsigned int   size;

public:
 VHMap(Type2  dflt,unsigned int sz=DEFAULT_INITIAL_CAPACITY);
 VHMap(VHMap& a);
 ~VHMap();

 Type2&          operator [] (Type1  key);
 
 void          del(Type1  key);
 
 Pix           first() const;
 void          next(Pix& i) const;
 Type1&          key(Pix i) const ;
 Type2&          contents(Pix i) const;
 
 Pix           seek(Type1  key);
 int           contains(Type1  key);
 
 void          clear(); 
 void          resize(unsigned int newsize = 0);
 
 int           OK();
};

template<class Type1, class Type2>
inline VHMap<Type1,Type2>::~VHMap()
{
  delete [] tab;
  delete [] cont;
  delete [] status;
}

template<class Type1, class Type2>
inline int VHMap<Type1,Type2>::contains(Type1  key)
{
  return seek(key) != 0;
}

template<class Type1, class Type2>
inline Type1& VHMap<Type1,Type2>::key(Pix i) const
{
  if (i == 0) error("null Pix");
  return *((Type1*)i);
}

template<class Type1, class Type2>
inline Type2& VHMap<Type1,Type2>::contents(Pix i) const
{
  if (i == 0) error("null Pix");
  return cont[((unsigned)(i) - (unsigned)(tab)) / sizeof(Type1)];
}

#endif
