/*
 *
 * Die Fehlercodes beginnen mit dem Praefix 'E_', gefolgt von einem
 * die Ursache beschreibenden Kuerzel (z.B. DETACH). Hinter den
 * Fehlercodes sind die Stellen ihrer Verwendung dokumentiert. Das
 * Hinzufuegen neuer Codes kann dadurch erfolgen, dass ein weiterer
 * Wert des Aufzaehlungstypes 'enum err_codes' definiert wird und ein
 * entsprechender Eintrag in der Datei 'common/error.c' vorgenommen
 * wird. Die Reihenfolge spielt bei Hinzunahme eines Fehlercodes weder
 * hier noch in 'common/error.c' eine Rolle.
 *
 */
#if !defined (_ERRORCODES_)

#define _ERRORCODES_

#include "config.h"
#include "rgglobal.h"

typedef enum
{
  E_SVCNOTLOC=1,
  E_CLNTCREATE,
  E_SVCCREATE,
  E_SVCREGISTER,
  E_SVCRUN,
  E_CLNTCALL,
  E_SVCOVERLOAD,
  E_CALLBACK,
  E_SVCEXIST,
  E_RIPCALLED,
  E_SETREL,
  E_BADHOST,
  E_SVCNOSTART,
  E_SVCNOFORK,
  E_BADGHOSTS,
  E_BADGEXED,
  E_DETACH,
  E_KERNEL,
  E_CLIENTS,
  E_CBHANDLES,
  E_GRAPHNUM,
  E_BADLOG,
  E_ISCLOSED
}
err_code_type;

/*
 * Programmabbruch mit zusaetzlicher Ausgabe des aufgetretenen
 * Fehlers.
 */
extern void
NORETURN(err_abort(err_code_type e_id));
extern void
NORETURN(err_abort_d(err_code_type e_id));

extern char *
err_text(err_code_type e_id);

void set_halt_cleanup_handler( void (*f)(void)); 

extern void
DisplayError(BOOLEAN    Halt,
	     BOOLEAN    ExecuteTrapHandler,
	     const char *ModuleName,
	     const char *ProcedureName,
	     const char *Name,
	     const char *ErrorMessage);

#endif




