/*********************************************************************/
/*                                                                   */
/* Copyright 1994/95/96 Carsten Friedrich, University of Passau.     */
/*                                                                   */
/* For details see the copyright file included in the distribution.  */
/* This notice must not be removed from the file.                    */
/*                                                                   */
/*********************************************************************/
/*
// Copyright 1994 Carsten Friedrich, Universitaet Passau
//
// $Author: friedric $
// $Date: 1996/05/06 14:24:42 $
// $RCSfile: FFGraphWindow.h,v $
// $Revision: 1.4 $
// $State: Exp $
//
*/

#ifndef FF_GRAPH_WINDOW
#define FF_GRAPH_WINDOW

#include "globdefs.h"

class FFGraph;
class FFGraphicNode;
class FFGraphicEdge;

#include <container/AVLSet.h>
#include <container/VOHSet.h>
#include <container/VHSet.h>
#include "FFPoint.h"
#include "FFGraphLabel.h"

#define ffGraphWindowType String("FFGraphWindow")

class FFGraphWindow  : public FFGraphLabel
{	
public:
 virtual BOOL parse(const String&){return YES;}
 virtual String unparse(){return String("");}
 //	const String& type() const {return ffGraphWindowType;}
 
 virtual void scaleXYZ(FFCoord , FFCoord , FFCoord )= NULL;
 virtual void rotateX(FFCoord)= NULL;
 virtual void rotateY(FFCoord)= NULL;
 virtual void rotateZ(FFCoord)= NULL;
 virtual void translate(FFCoord, FFCoord, FFCoord)= NULL;
	
 virtual FFPoint proj(const FFPoint&, const FFPoint& = FFPoint(0,0,0))=NULL;
 virtual FFPoint unProj(const FFPoint& A)=NULL;
 
 virtual FFPoint adjust(FFGraphicNode *A, FFPoint B)=NULL;
 virtual void setLabelOffset(int, int)=NULL;
        
  virtual void adjustWindowSize()= NULL;
  
  virtual String addNode(FFGraphicNode *n)=NULL;
  virtual String addEdge(FFGraphicEdge *e)=NULL;
  virtual String addLabel(FFGraphicNode *n)=NULL;
  virtual String addLabel(FFGraphicEdge *e)=NULL;

  virtual void changeColor(FFGraphicNode *n, String& )= NULL;
  virtual String changeToIcon(FFGraphicNode *n, const String&, 
                              const String& )=NULL;
  virtual String changeToCircle(FFGraphicNode *n)=NULL;
  virtual String changeToWindow(FFGraphicNode *n)=NULL;
  virtual void changeMask(FFGraphicNode *, const String& , const String&)= NULL;
  virtual void changeColor(FFGraphicEdge *, String& )= NULL;
  virtual void changeLabel(FFGraphicNode *, const String& )= NULL;
  virtual void changeLabel(FFGraphicEdge *, const String& )= NULL;

  virtual FFPoint getRange(const FFGraphicNode *) = NULL;

  virtual void setSpline(FFGraphicEdge *e, BOOL spline)= NULL;

  virtual void remove(FFGraphicNode *n)= NULL;
  virtual void remove(FFGraphicEdge *e)= NULL;

  virtual void removeLabel(FFGraphicNode *n)= NULL;
  virtual void removeLabel(FFGraphicEdge *e)= NULL;

  // wird u.a. bei verschieben aufgerufen
  virtual void updateGraph()= NULL;
  virtual void updateGraph(FFGraphicNode *n)= NULL;
  virtual void updateGraph(FFGraphicEdge *e)= NULL;

  virtual void setCurrent(FFGraphicNode *n)= NULL;
  virtual void setCurrent(FFGraphicEdge *e)= NULL;
  virtual void addToCurrent(FFGraphicNode *n)= NULL;
  virtual void selectIfNot(FFGraphicNode *n)= NULL;
  virtual void unsetCurrent()= NULL;
  virtual FFSet<FFGraphicNode *>& selectedNodes()=NULL;
  virtual BOOL isCurrent(FFGraphicNode *n)=NULL;
  
// Die zwei Methoden werden benutzt wenn man sich nicht sicher ist ob das
// Element wirklich selektiert ist.                              
  virtual void unset(FFGraphicNode *n)= NULL;
  virtual void unset(FFGraphicEdge *e)= NULL;

//  virtual void updateInspector()= NULL;
  virtual void sizeTo(int x, int y)= NULL;
  
  virtual void setUpdate(BOOL f)= NULL;
  virtual BOOL getUpdate()=NULL;
  virtual void update()= NULL;
	virtual int setTitle(const String& s)= NULL;
	virtual void setBusy()=NULL;
	virtual void unsetBusy()=NULL;
	
	virtual int mapWindow()= NULL;
  virtual int unmapWindow()= NULL;
	virtual int withdraw()= NULL;
  virtual int iconify()= NULL;
  virtual int deiconify()= NULL;

  FFGraphWindow(){_setType(ffGraphWindowType);}
  virtual ~FFGraphWindow(){}
};

#endif
