/*********************************************************************/
/*                                                                   */
/* Copyright 1994/95/96 Carsten Friedrich, University of Passau.     */
/*                                                                   */
/* For details see the copyright file included in the distribution.  */
/* This notice must not be removed from the file.                    */
/*                                                                   */
/*********************************************************************/
//-*-Mode: C++;-*-
#ifndef _newclass_h_
#define _newclass_h_

#if __GNUG__ >= 2
#  pragma interface
#endif

#include <globdefs.h>
#include <ffgraph/FFPoint.h>

//---- newclass -----------------------------------------------------------

class FFMatrix 
{
	FFPoint row[FFPOINT_SIZE];
	
public:
  FFMatrix(const FFMatrix&);
  FFMatrix();
  FFMatrix(const FFPoint&, const FFPoint&, 
					 const FFPoint&, const FFPoint&);
    
  BOOL operator == (const FFMatrix&) const;

  FFMatrix operator-() const;
  friend FFMatrix operator - (const FFMatrix&, const FFMatrix&);

	FFMatrix operator + (const FFMatrix&) const;
	FFMatrix operator* (const FFMatrix&) const;
	FFMatrix operator* (FFCoord) const;
	FFPoint operator* (const FFPoint&) const;
	friend FFPoint operator* (const FFPoint&, const FFMatrix&);
  FFMatrix operator / (FFCoord) const;

  void operator -= (const FFMatrix&);
  void operator += (const FFMatrix&);
  void operator *= (FFCoord);
  void operator *= (const FFMatrix&);
  void operator /= (FFCoord);

  FFMatrix& operator = (const FFMatrix&);
  char * operator()() const;
};

#endif
