#ifndef M3_AOC_H_
#define M3_AOC_H_

#include "m2_types.h"

/* if x is NIL -> 0, if x # NIL -> strlen(x) */
#define M3_AOC_NUMBER(x) (x ? strlen(x)+1 : 0)

/* open arrays in modula-3 == pointer to struct which first component 
   points to array contents and second component holds the array length. */

struct m3aoc__
{
#ifndef __STDC__
  CHAR *array;
#else
  const CHAR *array;
#endif /* STDC */
  CARDINAL length;
};

/* Use M3_AOX_T(x) for formal parameter declaration in function headers */
/* M3_AOX_VAR(x) declares a variable of type struct m3aox__. We need a variable,
   because we need a pointer to its contents. */
/* M3_AOC(x, str) initializes x (declares with M3_AOC_VAR) with str and returns
   a pointer to it. M3_AOB(x, array, len) does the same for byte arrays. The
   difference is, that the first determines array length with C's strlen 
   (0-termination!) and in the latter gets the length as argument. */
/* To access the fields of a M3_AOX_VAR variable, use M3_AOX_GETSTR and
   M3_AOX_GETNUM. */
 
#define M3_AOC_T(x) struct m3aoc__ *x
#define M3_AOC_VAR(x) struct m3aoc__ x ## __aoc
#define M3_AOC(x, att) ((struct m3aoc__ *)&(x ## __aoc = (struct m3aoc__){att,M3_AOC_NUMBER(att)}, x ## __aoc))
#define M3_AOC_GETSTR(x) (x->array)
#define M3_AOC_GETNUM(x) (x->length)

struct m3aob__
{
#ifndef __STDC__
  BYTE *array;
#else
  const BYTE *array;
#endif /* STDC */
  CARDINAL length;
};

#define M3_AOB_T(x) struct m3aob__ *x
#define M3_AOB_VAR(x) struct m3aob__ x ## __aob
#define M3_AOB(x, att, length) ((struct m3aob__ *)&(x ## __aob = (struct m3aob__){att,length}, x ## __aob))
#define M3_AOB_GETSTR(x) (x->array)
#define M3_AOB_GETNUM(x) (x->length)

#endif /* M3_AOC_H_ */
