/* ===========================================================================
 *
 *
 *                         Lehrstuhl fuer Informatik III
 *                                 Prof. Nagl 
 *            RWTH Aachen, Ahornstr. 55, 52074 Aachen, Germany
 *
 * ===========================================================================
 */


/* ---------------------------------------------------------------------------
 *			         MODULE INTERFACE
 *
 *   MODULE NAME:	op_handler
 *
 *   MODULE KEY :	op_table
 *
 *   DESCRIPTION:
 *   
 *   RCS IDENTIFICATION:
 *
 *    $Author: tcup $
 *    $Date: 1998/03/13 17:25:09 $
 *    $Revision: 1.1 $
 *    $State: Exp $
 *    $Locker:  $
 *    $RCSfile: op_table.h,v $
 *    $Log: op_table.h,v $
 *    Revision 1.1  1998/03/13 17:25:09  tcup
 *    Nun haben wir CVS !
 *
 *    Revision 1.2  1997/07/07 21:38:43  juergenk
 *    400 to 1000
 *
 *    Revision 1.1  1997/05/11 16:55:11  juergenk
 *    .
 *
 *    Revision 1.9  1997/04/25 11:05:28  juergenk
 *    schschnittstelle -> ecu
 *
 *    Revision 1.8  1997/04/24 08:17:32  krapp
 *    Set Cardinality hochgereicht
 *
 *    Revision 1.7  1997/04/21 17:48:20  juergenk
 *    fkt zur schnittstelle hochgereicht
 *
 *    Revision 1.6  1997/04/20 14:08:00  krapp
 *    Schnittstellen hochgereicht
 *
 *    Revision 1.5  1997/04/16 14:25:06  krapp
 *    Set Cardinality in die Schnittstelle aufgenommen
 *
 *    Revision 1.4  1997/03/26 09:18:55  juergenk
 *    no_change
 *
 *    Revision 1.3  1997/03/12 18:35:11  juergenk
 *    nothin changed
 *
 *    Revision 1.2  1997/03/01 11:54:02  juergenk
 *    -sto       write output to stdout
 *
 *    Revision 1.1  1997/02/26 15:57:07  juergenk
 *    final NEWffgraph
 *
 * ---------------------------------------------------------------------------
 */

                    /* Make sure that this file is included only once */
#ifndef op_table_H
#define op_table_H



/* ---------------------------------------------------------------------------
 *                                CONSTANTS
 * ---------------------------------------------------------------------------
 */

/* dedicated to Peter Klein: maxblabla = ??? 1000?? */
#define maxfunc 1000 // ex: 400
#define maxparam 25

#define FUNC_OK 0
#define TOO_MANY_FUNCS -1
#define WRONG_NUMBER -2

/* ---------------------------------------------------------------------------
 *                                INCLUDES
 * ---------------------------------------------------------------------------
 */
#include "C_PGC.h"
#include <tcl.h>
/* ---------------------------------------------------------------------------
 *                                FUNCTIONS
 * ---------------------------------------------------------------------------
 */

int op_SetIsOutParam(int index, int paraNo);

StandardType GetParamType(int index, int paraNo);

Cardinality GetCardinality(int index, int paraNo);

int op_SetCardinality(int index, int paraNo, Cardinality Card);


char *GetSchemeName(int index, int paraNo);


char *GetFuncName(int index);

int SetIndexName(int index, int paraNo, char *varname);

char *GetEvalString(int index);

int IsOutParam(int index, int paraNo);

int IsStandard(int index, int paraNo);

int IsSet(int index, int paraNo);

int op_SetParamType(int index, int paraNo, StandardType type);

int op_Func_AddFunc (char *name, int (*command)(Tcl_Interp*, int, char*), int no, char *eval);

int op_SetSchemeName(int index, int paraNo, char *name);

/*
  Appends a function to the dispatcher
  name is a unique function name
  command is the function which is will be executed by CallFunc*/

int Func_GetIndex(char *argv);
/* 
   liefert den Index des Arrayeintrages, der argv enthaelt oder 
   falls nicht enthalten maxfunc + 1 
*/

int IsIndexValid(int index);
/* prueft, ob ein gegebener Index ein zulaessiger Funktionsindex ist. */

int CallFunc( Tcl_Interp *interp, char *funcName, char *logName);

int op_GetNoOfParameters(int index);
/*
  Returns number of parameters of production/transaction
  determined by index
*/

char *GetIndexName(int index, int paraNo);

int op_SetIsNotStandard(int index, int paraNo);
// wird im gen code benutzt

/* ---------------------------------------------------------------------------
 *                            END OF FILE
 * ---------------------------------------------------------------------------
 */

#endif	/* op_table_H */
