#ifndef SETS_H
#define SETS_H

#ifdef __cplusplus
extern "C" {
#endif

typedef unsigned int WORD_T;
typedef unsigned int SETType;
#define SETLess -1
#define SETEqual -0
#define SETGreater 1

typedef int COMP_T(void *k1, void*k2);

void
SETCreateClass(               COMP_T CmpProc, 
                              WORD_T DataBytes,
                              WORD_T *ClassID);
  
void SETCreate( SETType *Set,
                WORD_T  ClassID);

void SETSetUndefined( SETType *Set) ;
BOOLEAN SETIsDefined( SETType Set);
void SETKill( SETType *Set);
CARDINAL SETCard( SETType Set);
CARDINAL SETCardUncompacted( SETType Set);
BOOLEAN SETIsEmpty( SETType Set);
void SETClear( SETType *Set);
void SETRemoveElement( SETType *Set,
                       char *Data);

void SETDeleteElement( SETType *Set,
                        char *Data,
                        BOOLEAN *fnd);

void SETInsert(        SETType *Set,
                       char *Data);

void SETReplaceValue(   SETType *Set,
                        char *Data,
                        BOOLEAN *fnd);

void SETGetValue( SETType Set,
                        char *Data,
                        BOOLEAN *fnd);


void SETExtractAnyElement( SETType *Set,
                           char *Data,
                           BOOLEAN *fnd);

void SETExtractRndElement( SETType *Set,
                        char *Data,
                        BOOLEAN *fnd);

BOOLEAN SETIn( SETType    Set,
               char *Data);

void SETCompare(   SETType FirstSet,
                   SETType SecondSet,
                   BOOLEAN *Equal,
                   BOOLEAN *Less,
                   BOOLEAN *Greater);

BOOLEAN SETIsSubset(   SETType FirstSet,
                       SETType SecondSet);
BOOLEAN SETIsStrictSubset(   SETType FirstSet,
                       SETType SecondSet);

BOOLEAN SETIsDisjunct(   SETType FirstSet,
                       SETType SecondSet);

void SETUnion(   SETType *FirstSet,
                 SETType SecondSet);

void SETIntersection(  SETType *FirstSet,
                       SETType SecondSet);

void    SETDifference(     SETType *FirstSet,
                           SETType SecondSet);
void    SETSymmetricDifference(     SETType *FirstSet,
                                    SETType SecondSet);

void    SETCompact(     SETType *Set);

void SETCopy( SETType Source,
              SETType *Target);
 
void SETGotoElement(    SETType *Set,
                        char *Data,
                        BOOLEAN *fnd);

void SETGotoMinimum( SETType *Set);
void SETGotoMaximum( SETType *Set);
void SETLoop( SETType *Set);

void SETGet       (     SETType *Set,
                        char *Data,
                        BOOLEAN *fnd);
void    SETCheckConsistency(     SETType Set);

void SETCreateForN( SETType *Set,
                WORD_T  ClassID,
                WORD_T  N);
void SETInsertUptoN(        SETType *Set,
                            char *Data);

void SETRangeLoop(      SETType *Set,
                        COMP_T CmpProc, 
                        char *Data);

void SETRangeExtractAnyElement(      SETType *Set,
                                     COMP_T CmpProc, 
                                     char *CmpData,
                                     char *Data,
                                     BOOLEAN *fnd);

#ifdef __cplusplus
}
#endif

#endif

