//-*-c++-*-
/* ===========================================================================
 *
 *
 *                         Lehrstuhl fuer Informatik III
 *                                 Prof. Nagl
 *            RWTH Aachen, Ahornstr. 55, 52074 Aachen, Germany
 *
 * ===========================================================================
 */

/* ---------------------------------------------------------------------------
 *			     FUNCTION IMPLEMENTATION
 *
 *   MODULE NAME:	NEWffgraph
 *
 *   FUNCTION:		<@@MK_func>
 *
 *   DESCRIPTION:	<@@Short explanation>
 *
 *   RCS IDENTIFICATION:
 *
 *    $Author: tcup $
 *    $Date: 1999/01/05 11:48:52 $
 *    $Revision: 1.8 $
 *    $State: Exp $
 *    $Locker:  $
 *    $RCSfile: ProtoMain.cc,v $
 *    $Log: ProtoMain.cc,v $
 *    Revision 1.8  1999/01/05 11:48:52  tcup
 *    Falsche Abfrage auf Parameter wieder elimiert. -ajw
 *
 *    Revision 1.7  1998/12/22 14:26:28  klausf
 *    Fehlende Parameter -> Hilfetext statt (core dumped)
 *
 *    Revision 1.6  1998/12/17 17:00:00  tcup
 *    Die globale Variable ConstrCheck wird noch gebrauicht, wenn sie auch keine
 *    Bedeutung mehr hat. -ajw
 *
 *    Revision 1.5  1998/12/17 16:40:30  tcup
 *    ConstrCheckOn als globale Variable eliminiert. -ajw
 *
 *    Revision 1.4  1998/12/09 18:39:56  tcup
 *    Schalter fuer Random Matching und Constraint Checking eingebaut
 *    (letzterer "disabled", weil Manfred da noch Bedenken hat ;-) ). -ajw
 *
 *    Revision 1.3  1998/05/19 17:26:44  tcup
 *    Fehler behoben. -ajw
 *
 *    Revision 1.2  1998/05/19 14:51:32  roetschk
 *    Parameter von CreateTypedGraph mit CopyStrToPGCMStr konvertiert[tr].
 *
 *    Revision 1.1  1998/03/13 16:37:47  tcup
 *    Nun haben wir CVS !
 *
 *    Revision 1.23  1998/01/27 18:17:47  winter
 *    WERKZEUG-Einstellungen nach VIEWSETTINGS umbenannt.
 *
 *    Revision 1.22  1998/01/20 17:39:16  winter
 *    Schreibfehler
 *
 *    Revision 1.21  1997/12/03 15:48:43  tatjana
 *    .
 *
 *    Revision 1.20  1997/12/02 14:29:26  tatjana
 *    .
 *
 *    Revision 1.19  1997/11/28 16:30:36  tatjana
 *    .
 *
 *    Revision 1.18  1997/11/28 16:00:45  tatjana
 *    Ein zusaetzliche Argument Werkzeug und Dateibearbeitung nach ecu_common/fh
 *
 *    Revision 1.17  1997/11/04 12:29:13  roetschk
 *    Anpassungen fr Linux-Release[tr].
 *
 *    Revision 1.16  1997/10/23 10:32:43  krapp
 *    auf prom3 umgestellt
 *
 *    Revision 1.15  1997/09/17 16:39:23  winter
 *    Bitte lass diesmal die Aenderung ankommen...
 *
 *    Revision 1.14  1997/09/12 16:25:38  krapp
 *    undo und redo umgestellt auf ecu_readgraph()
 *
 *    Revision 1.13  1997/08/18 11:43:46  juergenk
 *    wiederherstellung der aktullen version
 *
 *    Revision 1.11  1997/07/29 21:10:57  juergenk
 *    menu_tool init entfernt
 *
 *    Revision 1.10  1997/07/09 19:58:25  juergenk
 *    MiscCloseRoutine fuer beliebige abmelde-ops speziell aber fuer jochens tooltalk
 *
 *    Revision 1.9  1997/07/07 14:17:02  krapp
 *    Contraintattribut auch schoen auf false setzen
 *
 *    Revision 1.8  1997/05/07 15:36:45  krapp
 *    ich bein ein Prototyp
 *
 *    Revision 1.7  1997/05/03 17:14:04  juergenk
 *    makefile: pfad und schalter entfernt
 *
 *    Revision 1.6  1997/04/30 17:33:27  krapp
 *    keine Ahnung
 *
 *    Revision 1.5  1997/04/25 10:23:40  krapp
 *    Importierte Lbs werden jetzt mit beruecksichtigt
 *
 *    Revision 1.4  1997/04/24 10:56:00  krapp
 *    Erst Graph oeffen, dann alles andere machen
 *
 *    Revision 1.3  1997/04/23 21:00:46  juergenk
 *    nix
 *
 *    Revision 1.2  1997/04/23 09:28:25  krapp
 *    GraphModification rausgemommen
 *
 *    Revision 1.1  1997/04/21 14:37:49  krapp
 *    ein paar Umbennenungen
 *
 *    Revision 1.7  1997/04/18 15:02:59  krapp
 *    Ein file erzeugt wegen Benutzerfreundlichkeit !?!
 *
 *
 * ---------------------------------------------------------------------------
 */



/* RGRAS & PROGRES Includes */
#include "rgglobal.h"
#include "rgras.h"
#include "C_Global.h"
#include "C_GenericSets.h"
#include "C_PGC.h"
#include "C_DynamicLinkHandler.h"

#include <tcl.h>

#define FUNC_OK 0



BacktrackInfo ReExecInfo;

Surrogate Scheme;
SetDescription NodeSet;
GraphNumber HostGraph, ChoiceGraph;
ExternNumber ExtNo;
BacktrackInfo ChoiceInfo, BacktrackOut;
PoolName HostPoolName;
GraphName HostGraphName;

#include "ecu.h"
#include <stdio.h>

extern "C" {
	#include "ConstDecls._c"
	void P_PreInitScheme(GraphNumber HostGraph);
	void P_DownloadEvalProcs(GraphNumber HostGraph);
	int Init();


	int UndoCommand (Tcl_Interp *interp, int index, char *name) {
		CARDINAL step = 1;
  
		if (strcmp ((char*) HostGraphName, "") == 0) {
			ErrorMessage (interp, "No hostgraph open");
			return TCL_OK;
		}

		/* Get current checkpoint number of hostgraph */
		PGCUserUndo (HostGraph, ChoiceInfo, &step);

		ecu_readgraph();

		if (step != 1)
			ErrorMessage (interp, "No undo steps possible!");
  
		AppendLogMsg (interp, "Undo last step.");
		return TCL_OK;
	}


	int UndoAllCommand (Tcl_Interp *interp, int index, char *name) {
		CARDINAL step = 65000;

		if (strcmp ((char*) HostGraphName, "") == 0) {
			ErrorMessage (interp, "No hostgraph open");
			return TCL_OK;
		}

		PGCUserUndo (HostGraph, ChoiceInfo, &step);

		while (step == 65000)
			PGCUserUndo (HostGraph, ChoiceInfo, &step);

		ecu_readgraph();

		AppendLogMsg (interp, "Undo all steps");
		return TCL_OK;
	}


	int RedoCommand (Tcl_Interp *interp, int index, char *name) {
		CARDINAL step = 1;

		if (strcmp ((char*) HostGraphName, "") == 0) {
			ErrorMessage (interp, "No hostgraph open");
			return TCL_OK;
		}

		PGCUserRedo (HostGraph, ChoiceInfo, &step);

		if (step != 1) {
			ErrorMessage (interp, "No redo step possible.");
		}
		ecu_readgraph();
  
		AppendLogMsg (interp, "Redo");
		return TCL_OK;
	}


	int std_gen_Init () {
		int index;
		index = Func_AddFunc
			("Undo", &UndoCommand, 0, "dialog {Undo} {}");
		index = Func_AddFunc
			("UndoAll", &UndoAllCommand, 0, "dialog {UndoAll} {}");
		index = Func_AddFunc
			("Redo", &RedoCommand, 0, "dialog {Redo} {}");
		// Hack: Das folgende Kommando ist nur hier drin, weil das
		// letzte eingetragene Kommando nicht aufgerufen werden kann.
		// Irgendwo ist in TCUP noch ein Fehler. Somit steht zumindest
		// das Redo wieder zur Verfgung.
 		index = Func_AddFunc
			("Dummy", &RedoCommand, 0, "dialog {Dummy} {}");
 		return FUNC_OK;
	}


	void MiscCloseRoutine(){
		// this is the place for custom close operation for everyone
		// this procedure will be called in MTclWin as the very last
		// thing ecu does before exit 0
	};

	Ecu ecu;

} // end extern "C"


#ifndef USE_EXTERNAL_DEFS
	#include <tk.h>
	void user_mainloop() {
		// this is the place for custom mainloop
		Tk_MainLoop();
	}
	int user_startup (int argc, char *argv[]) {}
#else
	extern int user_startup (int argc, char *argv[]);
#endif


main(int argc, char **argv, char **envp){

        BOOLEAN NewGraph = FALSE;
	user_startup(argc, argv);
	// state, that this is a prototype
	ecu.IsProto = 1;

	strcpy((char*) HostPoolName,argv[1]);
	strcpy((char*) HostGraphName,argv[2]);
	// third parameter is view specific

	strcpy((char*) ecu.HostPoolName,  (char*) HostPoolName);
	strcpy((char*) ecu.HostGraphName, (char*) HostGraphName);

	ecu_PrepareGraphOpening(argc,argv,envp);

	ecu.HostGraph = 0;
	PGCInitSetDesc (&NodeSet);

	// does not check specification
	ecu_OpenGraph(argv[1], argv[2]); 
 
	if (ecu.HostGraph == 0) {
		fprintf(stderr,
			"\nGraph %s does not exist in pool %s ... creating ...\n",
			HostGraphName, HostPoolName);

		NewGraph = TRUE;
		PGCCreateTypedGraph(
			&(ecu.HostGraph), 
			&ExtNo, 
			&(ecu.ChoiceInfo), 
			CopyStrToPGCMStr(SpecName), 
			CopyStrToPGCMStr(Version),
			CopyStrToPGCMStr((char*) HostPoolName), 
			CopyStrToPGCMStr((char*) HostGraphName), 10);

		ecu.ChoiceGraph =  ecu.ChoiceInfo.Graph;

    
		HostGraph = ecu.HostGraph;
		ChoiceInfo = ecu.ChoiceInfo; 
		ChoiceGraph = ecu.ChoiceGraph;
    
		P_PreInitScheme (ecu.HostGraph);
    
	}
  
	ecu.ChoiceGraph =  ecu.ChoiceInfo.Graph;
  
	HostGraph = ecu.HostGraph;
	ChoiceInfo = ecu.ChoiceInfo; 
	ChoiceGraph = ecu.ChoiceGraph;
  
	P_DownloadEvalProcs (HostGraph);
  
	// Initialize PGC switches
	SetConstrCheck(FALSE);   // Contraint Checking Off
	SetRandomChoice(FALSE);  // Random Matches Off
  
	fh_init(argc, argv);
	FILE *fp;
	fp=fh_open("",1);
  
	ecu_VariableToolInit ();                                                              
	if (Init () != FUNC_OK) {  
		fprintf (stderr, "Init() in ProtoMain failed.\n");
		exit (1);
	}
	if (std_gen_Init () != FUNC_OK) {  
		fprintf (stderr, "std_gen_Init in ProtoMain failed.\n");
		exit (1);
	}
  
	ecu_VariableToolInitComplete ();           // sets a switch in PMemory
	ecu_OperationParameterToolInitComplete (); // "
	ecu_PriorityToolInitComplete();            // "

	// Wenn man noch etwas initialisieren mchte, knnte man dies hier tun
	/*
	if (NewGraph) {
	  // initialize graph using MAIN transaction
	  ChoiceInfo.Graph = ChoiceGraph;
	  PGCBeginTransaction(HostGraph, TRUE, &ChoiceInfo);
	  P_MAIN(&BacktrackOut, HostGraph, ChoiceInfo);
	  ChoiceInfo = PGCCheckAndSetBtInfo(BacktrackOut, FALSE, TRUE,
					    FALSE);
	  PGCEndTransaction(HostGraph, TRUE, ChoiceInfo);
	}
	*/

	// beyond gen_code init
	main_routine(argc,argv,envp);
}





/* ---------------------------------------------------------------------------
 *                            END OF FILE
 * ---------------------------------------------------------------------------
 */
